package transactions

// Code generated by github.com/algorand/msgp DO NOT EDIT.

import (
	"sort"

	"github.com/algorand/msgp/msgp"

	"github.com/algorand/go-algorand/config"
	"github.com/algorand/go-algorand/crypto"
	"github.com/algorand/go-algorand/data/basics"
)

// The following msgp objects are implemented in this file:
// ApplicationCallTxnFields
//             |-----> (*) MarshalMsg
//             |-----> (*) CanMarshalMsg
//             |-----> (*) UnmarshalMsg
//             |-----> (*) CanUnmarshalMsg
//             |-----> (*) Msgsize
//             |-----> (*) MsgIsZero
//
// ApplyData
//     |-----> (*) MarshalMsg
//     |-----> (*) CanMarshalMsg
//     |-----> (*) UnmarshalMsg
//     |-----> (*) CanUnmarshalMsg
//     |-----> (*) Msgsize
//     |-----> (*) MsgIsZero
//
// AssetConfigTxnFields
//           |-----> (*) MarshalMsg
//           |-----> (*) CanMarshalMsg
//           |-----> (*) UnmarshalMsg
//           |-----> (*) CanUnmarshalMsg
//           |-----> (*) Msgsize
//           |-----> (*) MsgIsZero
//
// AssetFreezeTxnFields
//           |-----> (*) MarshalMsg
//           |-----> (*) CanMarshalMsg
//           |-----> (*) UnmarshalMsg
//           |-----> (*) CanUnmarshalMsg
//           |-----> (*) Msgsize
//           |-----> (*) MsgIsZero
//
// AssetTransferTxnFields
//            |-----> (*) MarshalMsg
//            |-----> (*) CanMarshalMsg
//            |-----> (*) UnmarshalMsg
//            |-----> (*) CanUnmarshalMsg
//            |-----> (*) Msgsize
//            |-----> (*) MsgIsZero
//
// CompactCertTxnFields
//           |-----> (*) MarshalMsg
//           |-----> (*) CanMarshalMsg
//           |-----> (*) UnmarshalMsg
//           |-----> (*) CanUnmarshalMsg
//           |-----> (*) Msgsize
//           |-----> (*) MsgIsZero
//
// EvalDelta
//     |-----> (*) MarshalMsg
//     |-----> (*) CanMarshalMsg
//     |-----> (*) UnmarshalMsg
//     |-----> (*) CanUnmarshalMsg
//     |-----> (*) Msgsize
//     |-----> (*) MsgIsZero
//
// Header
//    |-----> (*) MarshalMsg
//    |-----> (*) CanMarshalMsg
//    |-----> (*) UnmarshalMsg
//    |-----> (*) CanUnmarshalMsg
//    |-----> (*) Msgsize
//    |-----> (*) MsgIsZero
//
// KeyregTxnFields
//        |-----> (*) MarshalMsg
//        |-----> (*) CanMarshalMsg
//        |-----> (*) UnmarshalMsg
//        |-----> (*) CanUnmarshalMsg
//        |-----> (*) Msgsize
//        |-----> (*) MsgIsZero
//
// LogicSig
//     |-----> (*) MarshalMsg
//     |-----> (*) CanMarshalMsg
//     |-----> (*) UnmarshalMsg
//     |-----> (*) CanUnmarshalMsg
//     |-----> (*) Msgsize
//     |-----> (*) MsgIsZero
//
// MinFeeError
//      |-----> MarshalMsg
//      |-----> CanMarshalMsg
//      |-----> (*) UnmarshalMsg
//      |-----> (*) CanUnmarshalMsg
//      |-----> Msgsize
//      |-----> MsgIsZero
//
// OnCompletion
//       |-----> MarshalMsg
//       |-----> CanMarshalMsg
//       |-----> (*) UnmarshalMsg
//       |-----> (*) CanUnmarshalMsg
//       |-----> Msgsize
//       |-----> MsgIsZero
//
// PaymentTxnFields
//         |-----> (*) MarshalMsg
//         |-----> (*) CanMarshalMsg
//         |-----> (*) UnmarshalMsg
//         |-----> (*) CanUnmarshalMsg
//         |-----> (*) Msgsize
//         |-----> (*) MsgIsZero
//
// Payset
//    |-----> MarshalMsg
//    |-----> CanMarshalMsg
//    |-----> (*) UnmarshalMsg
//    |-----> (*) CanUnmarshalMsg
//    |-----> Msgsize
//    |-----> MsgIsZero
//
// SignedTxn
//     |-----> (*) MarshalMsg
//     |-----> (*) CanMarshalMsg
//     |-----> (*) UnmarshalMsg
//     |-----> (*) CanUnmarshalMsg
//     |-----> (*) Msgsize
//     |-----> (*) MsgIsZero
//
// SignedTxnInBlock
//         |-----> (*) MarshalMsg
//         |-----> (*) CanMarshalMsg
//         |-----> (*) UnmarshalMsg
//         |-----> (*) CanUnmarshalMsg
//         |-----> (*) Msgsize
//         |-----> (*) MsgIsZero
//
// SignedTxnWithAD
//        |-----> (*) MarshalMsg
//        |-----> (*) CanMarshalMsg
//        |-----> (*) UnmarshalMsg
//        |-----> (*) CanUnmarshalMsg
//        |-----> (*) Msgsize
//        |-----> (*) MsgIsZero
//
// Transaction
//      |-----> (*) MarshalMsg
//      |-----> (*) CanMarshalMsg
//      |-----> (*) UnmarshalMsg
//      |-----> (*) CanUnmarshalMsg
//      |-----> (*) Msgsize
//      |-----> (*) MsgIsZero
//
// TxGroup
//    |-----> (*) MarshalMsg
//    |-----> (*) CanMarshalMsg
//    |-----> (*) UnmarshalMsg
//    |-----> (*) CanUnmarshalMsg
//    |-----> (*) Msgsize
//    |-----> (*) MsgIsZero
//
// Txid
//   |-----> (*) MarshalMsg
//   |-----> (*) CanMarshalMsg
//   |-----> (*) UnmarshalMsg
//   |-----> (*) CanUnmarshalMsg
//   |-----> (*) Msgsize
//   |-----> (*) MsgIsZero
//

// MarshalMsg implements msgp.Marshaler
func (z *ApplicationCallTxnFields) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0005Len := uint32(11)
	var zb0005Mask uint16 /* 12 bits */
	if len((*z).ApplicationArgs) == 0 {
		zb0005Len--
		zb0005Mask |= 0x2
	}
	if (*z).OnCompletion == 0 {
		zb0005Len--
		zb0005Mask |= 0x4
	}
	if len((*z).ApprovalProgram) == 0 {
		zb0005Len--
		zb0005Mask |= 0x8
	}
	if len((*z).ForeignAssets) == 0 {
		zb0005Len--
		zb0005Mask |= 0x10
	}
	if len((*z).Accounts) == 0 {
		zb0005Len--
		zb0005Mask |= 0x20
	}
	if (*z).ExtraProgramPages == 0 {
		zb0005Len--
		zb0005Mask |= 0x40
	}
	if len((*z).ForeignApps) == 0 {
		zb0005Len--
		zb0005Mask |= 0x80
	}
	if (*z).GlobalStateSchema.MsgIsZero() {
		zb0005Len--
		zb0005Mask |= 0x100
	}
	if (*z).ApplicationID.MsgIsZero() {
		zb0005Len--
		zb0005Mask |= 0x200
	}
	if (*z).LocalStateSchema.MsgIsZero() {
		zb0005Len--
		zb0005Mask |= 0x400
	}
	if len((*z).ClearStateProgram) == 0 {
		zb0005Len--
		zb0005Mask |= 0x800
	}
	// variable map header, size zb0005Len
	o = append(o, 0x80|uint8(zb0005Len))
	if zb0005Len != 0 {
		if (zb0005Mask & 0x2) == 0 { // if not empty
			// string "apaa"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x61)
			if (*z).ApplicationArgs == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).ApplicationArgs)))
			}
			for zb0001 := range (*z).ApplicationArgs {
				o = msgp.AppendBytes(o, (*z).ApplicationArgs[zb0001])
			}
		}
		if (zb0005Mask & 0x4) == 0 { // if not empty
			// string "apan"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x6e)
			o = msgp.AppendUint64(o, uint64((*z).OnCompletion))
		}
		if (zb0005Mask & 0x8) == 0 { // if not empty
			// string "apap"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x70)
			o = msgp.AppendBytes(o, (*z).ApprovalProgram)
		}
		if (zb0005Mask & 0x10) == 0 { // if not empty
			// string "apas"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x73)
			if (*z).ForeignAssets == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).ForeignAssets)))
			}
			for zb0004 := range (*z).ForeignAssets {
				o = (*z).ForeignAssets[zb0004].MarshalMsg(o)
			}
		}
		if (zb0005Mask & 0x20) == 0 { // if not empty
			// string "apat"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x74)
			if (*z).Accounts == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).Accounts)))
			}
			for zb0002 := range (*z).Accounts {
				o = (*z).Accounts[zb0002].MarshalMsg(o)
			}
		}
		if (zb0005Mask & 0x40) == 0 { // if not empty
			// string "apep"
			o = append(o, 0xa4, 0x61, 0x70, 0x65, 0x70)
			o = msgp.AppendUint32(o, (*z).ExtraProgramPages)
		}
		if (zb0005Mask & 0x80) == 0 { // if not empty
			// string "apfa"
			o = append(o, 0xa4, 0x61, 0x70, 0x66, 0x61)
			if (*z).ForeignApps == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).ForeignApps)))
			}
			for zb0003 := range (*z).ForeignApps {
				o = (*z).ForeignApps[zb0003].MarshalMsg(o)
			}
		}
		if (zb0005Mask & 0x100) == 0 { // if not empty
			// string "apgs"
			o = append(o, 0xa4, 0x61, 0x70, 0x67, 0x73)
			o = (*z).GlobalStateSchema.MarshalMsg(o)
		}
		if (zb0005Mask & 0x200) == 0 { // if not empty
			// string "apid"
			o = append(o, 0xa4, 0x61, 0x70, 0x69, 0x64)
			o = (*z).ApplicationID.MarshalMsg(o)
		}
		if (zb0005Mask & 0x400) == 0 { // if not empty
			// string "apls"
			o = append(o, 0xa4, 0x61, 0x70, 0x6c, 0x73)
			o = (*z).LocalStateSchema.MarshalMsg(o)
		}
		if (zb0005Mask & 0x800) == 0 { // if not empty
			// string "apsu"
			o = append(o, 0xa4, 0x61, 0x70, 0x73, 0x75)
			o = msgp.AppendBytes(o, (*z).ClearStateProgram)
		}
	}
	return
}

func (_ *ApplicationCallTxnFields) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*ApplicationCallTxnFields)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *ApplicationCallTxnFields) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0005 int
	var zb0006 bool
	zb0005, zb0006, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0005, zb0006, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0005 > 0 {
			zb0005--
			bts, err = (*z).ApplicationID.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApplicationID")
				return
			}
		}
		if zb0005 > 0 {
			zb0005--
			{
				var zb0007 uint64
				zb0007, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "OnCompletion")
					return
				}
				(*z).OnCompletion = OnCompletion(zb0007)
			}
		}
		if zb0005 > 0 {
			zb0005--
			var zb0008 int
			var zb0009 bool
			zb0008, zb0009, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApplicationArgs")
				return
			}
			if zb0008 > encodedMaxApplicationArgs {
				err = msgp.ErrOverflow(uint64(zb0008), uint64(encodedMaxApplicationArgs))
				err = msgp.WrapError(err, "struct-from-array", "ApplicationArgs")
				return
			}
			if zb0009 {
				(*z).ApplicationArgs = nil
			} else if (*z).ApplicationArgs != nil && cap((*z).ApplicationArgs) >= zb0008 {
				(*z).ApplicationArgs = ((*z).ApplicationArgs)[:zb0008]
			} else {
				(*z).ApplicationArgs = make([][]byte, zb0008)
			}
			for zb0001 := range (*z).ApplicationArgs {
				(*z).ApplicationArgs[zb0001], bts, err = msgp.ReadBytesBytes(bts, (*z).ApplicationArgs[zb0001])
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "ApplicationArgs", zb0001)
					return
				}
			}
		}
		if zb0005 > 0 {
			zb0005--
			var zb0010 int
			var zb0011 bool
			zb0010, zb0011, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Accounts")
				return
			}
			if zb0010 > encodedMaxAccounts {
				err = msgp.ErrOverflow(uint64(zb0010), uint64(encodedMaxAccounts))
				err = msgp.WrapError(err, "struct-from-array", "Accounts")
				return
			}
			if zb0011 {
				(*z).Accounts = nil
			} else if (*z).Accounts != nil && cap((*z).Accounts) >= zb0010 {
				(*z).Accounts = ((*z).Accounts)[:zb0010]
			} else {
				(*z).Accounts = make([]basics.Address, zb0010)
			}
			for zb0002 := range (*z).Accounts {
				bts, err = (*z).Accounts[zb0002].UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "Accounts", zb0002)
					return
				}
			}
		}
		if zb0005 > 0 {
			zb0005--
			var zb0012 int
			var zb0013 bool
			zb0012, zb0013, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ForeignApps")
				return
			}
			if zb0012 > encodedMaxForeignApps {
				err = msgp.ErrOverflow(uint64(zb0012), uint64(encodedMaxForeignApps))
				err = msgp.WrapError(err, "struct-from-array", "ForeignApps")
				return
			}
			if zb0013 {
				(*z).ForeignApps = nil
			} else if (*z).ForeignApps != nil && cap((*z).ForeignApps) >= zb0012 {
				(*z).ForeignApps = ((*z).ForeignApps)[:zb0012]
			} else {
				(*z).ForeignApps = make([]basics.AppIndex, zb0012)
			}
			for zb0003 := range (*z).ForeignApps {
				bts, err = (*z).ForeignApps[zb0003].UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "ForeignApps", zb0003)
					return
				}
			}
		}
		if zb0005 > 0 {
			zb0005--
			var zb0014 int
			var zb0015 bool
			zb0014, zb0015, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ForeignAssets")
				return
			}
			if zb0014 > encodedMaxForeignAssets {
				err = msgp.ErrOverflow(uint64(zb0014), uint64(encodedMaxForeignAssets))
				err = msgp.WrapError(err, "struct-from-array", "ForeignAssets")
				return
			}
			if zb0015 {
				(*z).ForeignAssets = nil
			} else if (*z).ForeignAssets != nil && cap((*z).ForeignAssets) >= zb0014 {
				(*z).ForeignAssets = ((*z).ForeignAssets)[:zb0014]
			} else {
				(*z).ForeignAssets = make([]basics.AssetIndex, zb0014)
			}
			for zb0004 := range (*z).ForeignAssets {
				bts, err = (*z).ForeignAssets[zb0004].UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "ForeignAssets", zb0004)
					return
				}
			}
		}
		if zb0005 > 0 {
			zb0005--
			bts, err = (*z).LocalStateSchema.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "LocalStateSchema")
				return
			}
		}
		if zb0005 > 0 {
			zb0005--
			bts, err = (*z).GlobalStateSchema.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "GlobalStateSchema")
				return
			}
		}
		if zb0005 > 0 {
			zb0005--
			var zb0016 int
			zb0016, err = msgp.ReadBytesBytesHeader(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApprovalProgram")
				return
			}
			if zb0016 > config.MaxAvailableAppProgramLen {
				err = msgp.ErrOverflow(uint64(zb0016), uint64(config.MaxAvailableAppProgramLen))
				return
			}
			(*z).ApprovalProgram, bts, err = msgp.ReadBytesBytes(bts, (*z).ApprovalProgram)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApprovalProgram")
				return
			}
		}
		if zb0005 > 0 {
			zb0005--
			var zb0017 int
			zb0017, err = msgp.ReadBytesBytesHeader(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ClearStateProgram")
				return
			}
			if zb0017 > config.MaxAvailableAppProgramLen {
				err = msgp.ErrOverflow(uint64(zb0017), uint64(config.MaxAvailableAppProgramLen))
				return
			}
			(*z).ClearStateProgram, bts, err = msgp.ReadBytesBytes(bts, (*z).ClearStateProgram)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ClearStateProgram")
				return
			}
		}
		if zb0005 > 0 {
			zb0005--
			(*z).ExtraProgramPages, bts, err = msgp.ReadUint32Bytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ExtraProgramPages")
				return
			}
		}
		if zb0005 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0005)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0006 {
			(*z) = ApplicationCallTxnFields{}
		}
		for zb0005 > 0 {
			zb0005--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "apid":
				bts, err = (*z).ApplicationID.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ApplicationID")
					return
				}
			case "apan":
				{
					var zb0018 uint64
					zb0018, bts, err = msgp.ReadUint64Bytes(bts)
					if err != nil {
						err = msgp.WrapError(err, "OnCompletion")
						return
					}
					(*z).OnCompletion = OnCompletion(zb0018)
				}
			case "apaa":
				var zb0019 int
				var zb0020 bool
				zb0019, zb0020, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "ApplicationArgs")
					return
				}
				if zb0019 > encodedMaxApplicationArgs {
					err = msgp.ErrOverflow(uint64(zb0019), uint64(encodedMaxApplicationArgs))
					err = msgp.WrapError(err, "ApplicationArgs")
					return
				}
				if zb0020 {
					(*z).ApplicationArgs = nil
				} else if (*z).ApplicationArgs != nil && cap((*z).ApplicationArgs) >= zb0019 {
					(*z).ApplicationArgs = ((*z).ApplicationArgs)[:zb0019]
				} else {
					(*z).ApplicationArgs = make([][]byte, zb0019)
				}
				for zb0001 := range (*z).ApplicationArgs {
					(*z).ApplicationArgs[zb0001], bts, err = msgp.ReadBytesBytes(bts, (*z).ApplicationArgs[zb0001])
					if err != nil {
						err = msgp.WrapError(err, "ApplicationArgs", zb0001)
						return
					}
				}
			case "apat":
				var zb0021 int
				var zb0022 bool
				zb0021, zb0022, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "Accounts")
					return
				}
				if zb0021 > encodedMaxAccounts {
					err = msgp.ErrOverflow(uint64(zb0021), uint64(encodedMaxAccounts))
					err = msgp.WrapError(err, "Accounts")
					return
				}
				if zb0022 {
					(*z).Accounts = nil
				} else if (*z).Accounts != nil && cap((*z).Accounts) >= zb0021 {
					(*z).Accounts = ((*z).Accounts)[:zb0021]
				} else {
					(*z).Accounts = make([]basics.Address, zb0021)
				}
				for zb0002 := range (*z).Accounts {
					bts, err = (*z).Accounts[zb0002].UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "Accounts", zb0002)
						return
					}
				}
			case "apfa":
				var zb0023 int
				var zb0024 bool
				zb0023, zb0024, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "ForeignApps")
					return
				}
				if zb0023 > encodedMaxForeignApps {
					err = msgp.ErrOverflow(uint64(zb0023), uint64(encodedMaxForeignApps))
					err = msgp.WrapError(err, "ForeignApps")
					return
				}
				if zb0024 {
					(*z).ForeignApps = nil
				} else if (*z).ForeignApps != nil && cap((*z).ForeignApps) >= zb0023 {
					(*z).ForeignApps = ((*z).ForeignApps)[:zb0023]
				} else {
					(*z).ForeignApps = make([]basics.AppIndex, zb0023)
				}
				for zb0003 := range (*z).ForeignApps {
					bts, err = (*z).ForeignApps[zb0003].UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "ForeignApps", zb0003)
						return
					}
				}
			case "apas":
				var zb0025 int
				var zb0026 bool
				zb0025, zb0026, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "ForeignAssets")
					return
				}
				if zb0025 > encodedMaxForeignAssets {
					err = msgp.ErrOverflow(uint64(zb0025), uint64(encodedMaxForeignAssets))
					err = msgp.WrapError(err, "ForeignAssets")
					return
				}
				if zb0026 {
					(*z).ForeignAssets = nil
				} else if (*z).ForeignAssets != nil && cap((*z).ForeignAssets) >= zb0025 {
					(*z).ForeignAssets = ((*z).ForeignAssets)[:zb0025]
				} else {
					(*z).ForeignAssets = make([]basics.AssetIndex, zb0025)
				}
				for zb0004 := range (*z).ForeignAssets {
					bts, err = (*z).ForeignAssets[zb0004].UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "ForeignAssets", zb0004)
						return
					}
				}
			case "apls":
				bts, err = (*z).LocalStateSchema.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "LocalStateSchema")
					return
				}
			case "apgs":
				bts, err = (*z).GlobalStateSchema.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "GlobalStateSchema")
					return
				}
			case "apap":
				var zb0027 int
				zb0027, err = msgp.ReadBytesBytesHeader(bts)
				if err != nil {
					err = msgp.WrapError(err, "ApprovalProgram")
					return
				}
				if zb0027 > config.MaxAvailableAppProgramLen {
					err = msgp.ErrOverflow(uint64(zb0027), uint64(config.MaxAvailableAppProgramLen))
					return
				}
				(*z).ApprovalProgram, bts, err = msgp.ReadBytesBytes(bts, (*z).ApprovalProgram)
				if err != nil {
					err = msgp.WrapError(err, "ApprovalProgram")
					return
				}
			case "apsu":
				var zb0028 int
				zb0028, err = msgp.ReadBytesBytesHeader(bts)
				if err != nil {
					err = msgp.WrapError(err, "ClearStateProgram")
					return
				}
				if zb0028 > config.MaxAvailableAppProgramLen {
					err = msgp.ErrOverflow(uint64(zb0028), uint64(config.MaxAvailableAppProgramLen))
					return
				}
				(*z).ClearStateProgram, bts, err = msgp.ReadBytesBytes(bts, (*z).ClearStateProgram)
				if err != nil {
					err = msgp.WrapError(err, "ClearStateProgram")
					return
				}
			case "apep":
				(*z).ExtraProgramPages, bts, err = msgp.ReadUint32Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "ExtraProgramPages")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *ApplicationCallTxnFields) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*ApplicationCallTxnFields)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *ApplicationCallTxnFields) Msgsize() (s int) {
	s = 1 + 5 + (*z).ApplicationID.Msgsize() + 5 + msgp.Uint64Size + 5 + msgp.ArrayHeaderSize
	for zb0001 := range (*z).ApplicationArgs {
		s += msgp.BytesPrefixSize + len((*z).ApplicationArgs[zb0001])
	}
	s += 5 + msgp.ArrayHeaderSize
	for zb0002 := range (*z).Accounts {
		s += (*z).Accounts[zb0002].Msgsize()
	}
	s += 5 + msgp.ArrayHeaderSize
	for zb0003 := range (*z).ForeignApps {
		s += (*z).ForeignApps[zb0003].Msgsize()
	}
	s += 5 + msgp.ArrayHeaderSize
	for zb0004 := range (*z).ForeignAssets {
		s += (*z).ForeignAssets[zb0004].Msgsize()
	}
	s += 5 + (*z).LocalStateSchema.Msgsize() + 5 + (*z).GlobalStateSchema.Msgsize() + 5 + msgp.BytesPrefixSize + len((*z).ApprovalProgram) + 5 + msgp.BytesPrefixSize + len((*z).ClearStateProgram) + 5 + msgp.Uint32Size
	return
}

// MsgIsZero returns whether this is a zero value
func (z *ApplicationCallTxnFields) MsgIsZero() bool {
	return ((*z).ApplicationID.MsgIsZero()) && ((*z).OnCompletion == 0) && (len((*z).ApplicationArgs) == 0) && (len((*z).Accounts) == 0) && (len((*z).ForeignApps) == 0) && (len((*z).ForeignAssets) == 0) && ((*z).LocalStateSchema.MsgIsZero()) && ((*z).GlobalStateSchema.MsgIsZero()) && (len((*z).ApprovalProgram) == 0) && (len((*z).ClearStateProgram) == 0) && ((*z).ExtraProgramPages == 0)
}

// MarshalMsg implements msgp.Marshaler
func (z *ApplyData) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(8)
	var zb0001Mask uint16 /* 9 bits */
	if (*z).AssetClosingAmount == 0 {
		zb0001Len--
		zb0001Mask |= 0x2
	}
	if (*z).ApplicationID.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4
	}
	if (*z).ClosingAmount.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x8
	}
	if (*z).ConfigAsset.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x10
	}
	if (*z).EvalDelta.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x20
	}
	if (*z).CloseRewards.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x40
	}
	if (*z).ReceiverRewards.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x80
	}
	if (*z).SenderRewards.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x100
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x2) == 0 { // if not empty
			// string "aca"
			o = append(o, 0xa3, 0x61, 0x63, 0x61)
			o = msgp.AppendUint64(o, (*z).AssetClosingAmount)
		}
		if (zb0001Mask & 0x4) == 0 { // if not empty
			// string "apid"
			o = append(o, 0xa4, 0x61, 0x70, 0x69, 0x64)
			o = (*z).ApplicationID.MarshalMsg(o)
		}
		if (zb0001Mask & 0x8) == 0 { // if not empty
			// string "ca"
			o = append(o, 0xa2, 0x63, 0x61)
			o = (*z).ClosingAmount.MarshalMsg(o)
		}
		if (zb0001Mask & 0x10) == 0 { // if not empty
			// string "caid"
			o = append(o, 0xa4, 0x63, 0x61, 0x69, 0x64)
			o = (*z).ConfigAsset.MarshalMsg(o)
		}
		if (zb0001Mask & 0x20) == 0 { // if not empty
			// string "dt"
			o = append(o, 0xa2, 0x64, 0x74)
			o = (*z).EvalDelta.MarshalMsg(o)
		}
		if (zb0001Mask & 0x40) == 0 { // if not empty
			// string "rc"
			o = append(o, 0xa2, 0x72, 0x63)
			o = (*z).CloseRewards.MarshalMsg(o)
		}
		if (zb0001Mask & 0x80) == 0 { // if not empty
			// string "rr"
			o = append(o, 0xa2, 0x72, 0x72)
			o = (*z).ReceiverRewards.MarshalMsg(o)
		}
		if (zb0001Mask & 0x100) == 0 { // if not empty
			// string "rs"
			o = append(o, 0xa2, 0x72, 0x73)
			o = (*z).SenderRewards.MarshalMsg(o)
		}
	}
	return
}

func (_ *ApplyData) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*ApplyData)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *ApplyData) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ClosingAmount.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ClosingAmount")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			(*z).AssetClosingAmount, bts, err = msgp.ReadUint64Bytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetClosingAmount")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SenderRewards.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "SenderRewards")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ReceiverRewards.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ReceiverRewards")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).CloseRewards.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "CloseRewards")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).EvalDelta.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "EvalDelta")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ConfigAsset.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ConfigAsset")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ApplicationID.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApplicationID")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = ApplyData{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "ca":
				bts, err = (*z).ClosingAmount.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ClosingAmount")
					return
				}
			case "aca":
				(*z).AssetClosingAmount, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetClosingAmount")
					return
				}
			case "rs":
				bts, err = (*z).SenderRewards.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "SenderRewards")
					return
				}
			case "rr":
				bts, err = (*z).ReceiverRewards.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ReceiverRewards")
					return
				}
			case "rc":
				bts, err = (*z).CloseRewards.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "CloseRewards")
					return
				}
			case "dt":
				bts, err = (*z).EvalDelta.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "EvalDelta")
					return
				}
			case "caid":
				bts, err = (*z).ConfigAsset.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ConfigAsset")
					return
				}
			case "apid":
				bts, err = (*z).ApplicationID.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ApplicationID")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *ApplyData) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*ApplyData)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *ApplyData) Msgsize() (s int) {
	s = 1 + 3 + (*z).ClosingAmount.Msgsize() + 4 + msgp.Uint64Size + 3 + (*z).SenderRewards.Msgsize() + 3 + (*z).ReceiverRewards.Msgsize() + 3 + (*z).CloseRewards.Msgsize() + 3 + (*z).EvalDelta.Msgsize() + 5 + (*z).ConfigAsset.Msgsize() + 5 + (*z).ApplicationID.Msgsize()
	return
}

// MsgIsZero returns whether this is a zero value
func (z *ApplyData) MsgIsZero() bool {
	return ((*z).ClosingAmount.MsgIsZero()) && ((*z).AssetClosingAmount == 0) && ((*z).SenderRewards.MsgIsZero()) && ((*z).ReceiverRewards.MsgIsZero()) && ((*z).CloseRewards.MsgIsZero()) && ((*z).EvalDelta.MsgIsZero()) && ((*z).ConfigAsset.MsgIsZero()) && ((*z).ApplicationID.MsgIsZero())
}

// MarshalMsg implements msgp.Marshaler
func (z *AssetConfigTxnFields) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(2)
	var zb0001Mask uint8 /* 3 bits */
	if (*z).AssetParams.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x2
	}
	if (*z).ConfigAsset.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x2) == 0 { // if not empty
			// string "apar"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x72)
			o = (*z).AssetParams.MarshalMsg(o)
		}
		if (zb0001Mask & 0x4) == 0 { // if not empty
			// string "caid"
			o = append(o, 0xa4, 0x63, 0x61, 0x69, 0x64)
			o = (*z).ConfigAsset.MarshalMsg(o)
		}
	}
	return
}

func (_ *AssetConfigTxnFields) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*AssetConfigTxnFields)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *AssetConfigTxnFields) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ConfigAsset.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ConfigAsset")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).AssetParams.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetParams")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = AssetConfigTxnFields{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "caid":
				bts, err = (*z).ConfigAsset.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ConfigAsset")
					return
				}
			case "apar":
				bts, err = (*z).AssetParams.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetParams")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *AssetConfigTxnFields) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*AssetConfigTxnFields)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *AssetConfigTxnFields) Msgsize() (s int) {
	s = 1 + 5 + (*z).ConfigAsset.Msgsize() + 5 + (*z).AssetParams.Msgsize()
	return
}

// MsgIsZero returns whether this is a zero value
func (z *AssetConfigTxnFields) MsgIsZero() bool {
	return ((*z).ConfigAsset.MsgIsZero()) && ((*z).AssetParams.MsgIsZero())
}

// MarshalMsg implements msgp.Marshaler
func (z *AssetFreezeTxnFields) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(3)
	var zb0001Mask uint8 /* 4 bits */
	if (*z).AssetFrozen == false {
		zb0001Len--
		zb0001Mask |= 0x2
	}
	if (*z).FreezeAccount.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4
	}
	if (*z).FreezeAsset.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x8
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x2) == 0 { // if not empty
			// string "afrz"
			o = append(o, 0xa4, 0x61, 0x66, 0x72, 0x7a)
			o = msgp.AppendBool(o, (*z).AssetFrozen)
		}
		if (zb0001Mask & 0x4) == 0 { // if not empty
			// string "fadd"
			o = append(o, 0xa4, 0x66, 0x61, 0x64, 0x64)
			o = (*z).FreezeAccount.MarshalMsg(o)
		}
		if (zb0001Mask & 0x8) == 0 { // if not empty
			// string "faid"
			o = append(o, 0xa4, 0x66, 0x61, 0x69, 0x64)
			o = (*z).FreezeAsset.MarshalMsg(o)
		}
	}
	return
}

func (_ *AssetFreezeTxnFields) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*AssetFreezeTxnFields)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *AssetFreezeTxnFields) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).FreezeAccount.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "FreezeAccount")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).FreezeAsset.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "FreezeAsset")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			(*z).AssetFrozen, bts, err = msgp.ReadBoolBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetFrozen")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = AssetFreezeTxnFields{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "fadd":
				bts, err = (*z).FreezeAccount.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "FreezeAccount")
					return
				}
			case "faid":
				bts, err = (*z).FreezeAsset.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "FreezeAsset")
					return
				}
			case "afrz":
				(*z).AssetFrozen, bts, err = msgp.ReadBoolBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetFrozen")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *AssetFreezeTxnFields) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*AssetFreezeTxnFields)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *AssetFreezeTxnFields) Msgsize() (s int) {
	s = 1 + 5 + (*z).FreezeAccount.Msgsize() + 5 + (*z).FreezeAsset.Msgsize() + 5 + msgp.BoolSize
	return
}

// MsgIsZero returns whether this is a zero value
func (z *AssetFreezeTxnFields) MsgIsZero() bool {
	return ((*z).FreezeAccount.MsgIsZero()) && ((*z).FreezeAsset.MsgIsZero()) && ((*z).AssetFrozen == false)
}

// MarshalMsg implements msgp.Marshaler
func (z *AssetTransferTxnFields) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(5)
	var zb0001Mask uint8 /* 6 bits */
	if (*z).AssetAmount == 0 {
		zb0001Len--
		zb0001Mask |= 0x2
	}
	if (*z).AssetCloseTo.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4
	}
	if (*z).AssetReceiver.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x8
	}
	if (*z).AssetSender.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x10
	}
	if (*z).XferAsset.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x20
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x2) == 0 { // if not empty
			// string "aamt"
			o = append(o, 0xa4, 0x61, 0x61, 0x6d, 0x74)
			o = msgp.AppendUint64(o, (*z).AssetAmount)
		}
		if (zb0001Mask & 0x4) == 0 { // if not empty
			// string "aclose"
			o = append(o, 0xa6, 0x61, 0x63, 0x6c, 0x6f, 0x73, 0x65)
			o = (*z).AssetCloseTo.MarshalMsg(o)
		}
		if (zb0001Mask & 0x8) == 0 { // if not empty
			// string "arcv"
			o = append(o, 0xa4, 0x61, 0x72, 0x63, 0x76)
			o = (*z).AssetReceiver.MarshalMsg(o)
		}
		if (zb0001Mask & 0x10) == 0 { // if not empty
			// string "asnd"
			o = append(o, 0xa4, 0x61, 0x73, 0x6e, 0x64)
			o = (*z).AssetSender.MarshalMsg(o)
		}
		if (zb0001Mask & 0x20) == 0 { // if not empty
			// string "xaid"
			o = append(o, 0xa4, 0x78, 0x61, 0x69, 0x64)
			o = (*z).XferAsset.MarshalMsg(o)
		}
	}
	return
}

func (_ *AssetTransferTxnFields) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*AssetTransferTxnFields)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *AssetTransferTxnFields) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).XferAsset.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "XferAsset")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			(*z).AssetAmount, bts, err = msgp.ReadUint64Bytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetAmount")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).AssetSender.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetSender")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).AssetReceiver.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetReceiver")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).AssetCloseTo.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetCloseTo")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = AssetTransferTxnFields{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "xaid":
				bts, err = (*z).XferAsset.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "XferAsset")
					return
				}
			case "aamt":
				(*z).AssetAmount, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetAmount")
					return
				}
			case "asnd":
				bts, err = (*z).AssetSender.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetSender")
					return
				}
			case "arcv":
				bts, err = (*z).AssetReceiver.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetReceiver")
					return
				}
			case "aclose":
				bts, err = (*z).AssetCloseTo.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetCloseTo")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *AssetTransferTxnFields) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*AssetTransferTxnFields)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *AssetTransferTxnFields) Msgsize() (s int) {
	s = 1 + 5 + (*z).XferAsset.Msgsize() + 5 + msgp.Uint64Size + 5 + (*z).AssetSender.Msgsize() + 5 + (*z).AssetReceiver.Msgsize() + 7 + (*z).AssetCloseTo.Msgsize()
	return
}

// MsgIsZero returns whether this is a zero value
func (z *AssetTransferTxnFields) MsgIsZero() bool {
	return ((*z).XferAsset.MsgIsZero()) && ((*z).AssetAmount == 0) && ((*z).AssetSender.MsgIsZero()) && ((*z).AssetReceiver.MsgIsZero()) && ((*z).AssetCloseTo.MsgIsZero())
}

// MarshalMsg implements msgp.Marshaler
func (z *CompactCertTxnFields) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(3)
	var zb0001Mask uint8 /* 4 bits */
	if (*z).Cert.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x2
	}
	if (*z).CertRound.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4
	}
	if (*z).CertType.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x8
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x2) == 0 { // if not empty
			// string "cert"
			o = append(o, 0xa4, 0x63, 0x65, 0x72, 0x74)
			o = (*z).Cert.MarshalMsg(o)
		}
		if (zb0001Mask & 0x4) == 0 { // if not empty
			// string "certrnd"
			o = append(o, 0xa7, 0x63, 0x65, 0x72, 0x74, 0x72, 0x6e, 0x64)
			o = (*z).CertRound.MarshalMsg(o)
		}
		if (zb0001Mask & 0x8) == 0 { // if not empty
			// string "certtype"
			o = append(o, 0xa8, 0x63, 0x65, 0x72, 0x74, 0x74, 0x79, 0x70, 0x65)
			o = (*z).CertType.MarshalMsg(o)
		}
	}
	return
}

func (_ *CompactCertTxnFields) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*CompactCertTxnFields)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *CompactCertTxnFields) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).CertRound.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "CertRound")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).CertType.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "CertType")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).Cert.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Cert")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = CompactCertTxnFields{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "certrnd":
				bts, err = (*z).CertRound.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "CertRound")
					return
				}
			case "certtype":
				bts, err = (*z).CertType.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "CertType")
					return
				}
			case "cert":
				bts, err = (*z).Cert.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Cert")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *CompactCertTxnFields) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*CompactCertTxnFields)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *CompactCertTxnFields) Msgsize() (s int) {
	s = 1 + 8 + (*z).CertRound.Msgsize() + 9 + (*z).CertType.Msgsize() + 5 + (*z).Cert.Msgsize()
	return
}

// MsgIsZero returns whether this is a zero value
func (z *CompactCertTxnFields) MsgIsZero() bool {
	return ((*z).CertRound.MsgIsZero()) && ((*z).CertType.MsgIsZero()) && ((*z).Cert.MsgIsZero())
}

// MarshalMsg implements msgp.Marshaler
func (z *EvalDelta) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0005Len := uint32(4)
	var zb0005Mask uint8 /* 5 bits */
	if (*z).GlobalDelta.MsgIsZero() {
		zb0005Len--
		zb0005Mask |= 0x2
	}
	if len((*z).InnerTxns) == 0 {
		zb0005Len--
		zb0005Mask |= 0x4
	}
	if len((*z).LocalDeltas) == 0 {
		zb0005Len--
		zb0005Mask |= 0x8
	}
	if len((*z).Logs) == 0 {
		zb0005Len--
		zb0005Mask |= 0x10
	}
	// variable map header, size zb0005Len
	o = append(o, 0x80|uint8(zb0005Len))
	if zb0005Len != 0 {
		if (zb0005Mask & 0x2) == 0 { // if not empty
			// string "gd"
			o = append(o, 0xa2, 0x67, 0x64)
			o = (*z).GlobalDelta.MarshalMsg(o)
		}
		if (zb0005Mask & 0x4) == 0 { // if not empty
			// string "itx"
			o = append(o, 0xa3, 0x69, 0x74, 0x78)
			if (*z).InnerTxns == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).InnerTxns)))
			}
			for zb0004 := range (*z).InnerTxns {
				o = (*z).InnerTxns[zb0004].MarshalMsg(o)
			}
		}
		if (zb0005Mask & 0x8) == 0 { // if not empty
			// string "ld"
			o = append(o, 0xa2, 0x6c, 0x64)
			if (*z).LocalDeltas == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendMapHeader(o, uint32(len((*z).LocalDeltas)))
			}
			zb0001_keys := make([]uint64, 0, len((*z).LocalDeltas))
			for zb0001 := range (*z).LocalDeltas {
				zb0001_keys = append(zb0001_keys, zb0001)
			}
			sort.Sort(SortUint64(zb0001_keys))
			for _, zb0001 := range zb0001_keys {
				zb0002 := (*z).LocalDeltas[zb0001]
				_ = zb0002
				o = msgp.AppendUint64(o, zb0001)
				o = zb0002.MarshalMsg(o)
			}
		}
		if (zb0005Mask & 0x10) == 0 { // if not empty
			// string "lg"
			o = append(o, 0xa2, 0x6c, 0x67)
			if (*z).Logs == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).Logs)))
			}
			for zb0003 := range (*z).Logs {
				o = msgp.AppendString(o, (*z).Logs[zb0003])
			}
		}
	}
	return
}

func (_ *EvalDelta) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*EvalDelta)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *EvalDelta) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0005 int
	var zb0006 bool
	zb0005, zb0006, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0005, zb0006, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0005 > 0 {
			zb0005--
			bts, err = (*z).GlobalDelta.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "GlobalDelta")
				return
			}
		}
		if zb0005 > 0 {
			zb0005--
			var zb0007 int
			var zb0008 bool
			zb0007, zb0008, bts, err = msgp.ReadMapHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "LocalDeltas")
				return
			}
			if zb0007 > config.MaxEvalDeltaAccounts {
				err = msgp.ErrOverflow(uint64(zb0007), uint64(config.MaxEvalDeltaAccounts))
				err = msgp.WrapError(err, "struct-from-array", "LocalDeltas")
				return
			}
			if zb0008 {
				(*z).LocalDeltas = nil
			} else if (*z).LocalDeltas == nil {
				(*z).LocalDeltas = make(map[uint64]basics.StateDelta, zb0007)
			}
			for zb0007 > 0 {
				var zb0001 uint64
				var zb0002 basics.StateDelta
				zb0007--
				zb0001, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "LocalDeltas")
					return
				}
				bts, err = zb0002.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "LocalDeltas", zb0001)
					return
				}
				(*z).LocalDeltas[zb0001] = zb0002
			}
		}
		if zb0005 > 0 {
			zb0005--
			var zb0009 int
			var zb0010 bool
			zb0009, zb0010, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Logs")
				return
			}
			if zb0009 > config.MaxLogCalls {
				err = msgp.ErrOverflow(uint64(zb0009), uint64(config.MaxLogCalls))
				err = msgp.WrapError(err, "struct-from-array", "Logs")
				return
			}
			if zb0010 {
				(*z).Logs = nil
			} else if (*z).Logs != nil && cap((*z).Logs) >= zb0009 {
				(*z).Logs = ((*z).Logs)[:zb0009]
			} else {
				(*z).Logs = make([]string, zb0009)
			}
			for zb0003 := range (*z).Logs {
				(*z).Logs[zb0003], bts, err = msgp.ReadStringBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "Logs", zb0003)
					return
				}
			}
		}
		if zb0005 > 0 {
			zb0005--
			var zb0011 int
			var zb0012 bool
			zb0011, zb0012, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "InnerTxns")
				return
			}
			if zb0011 > config.MaxInnerTransactionsPerDelta {
				err = msgp.ErrOverflow(uint64(zb0011), uint64(config.MaxInnerTransactionsPerDelta))
				err = msgp.WrapError(err, "struct-from-array", "InnerTxns")
				return
			}
			if zb0012 {
				(*z).InnerTxns = nil
			} else if (*z).InnerTxns != nil && cap((*z).InnerTxns) >= zb0011 {
				(*z).InnerTxns = ((*z).InnerTxns)[:zb0011]
			} else {
				(*z).InnerTxns = make([]SignedTxnWithAD, zb0011)
			}
			for zb0004 := range (*z).InnerTxns {
				bts, err = (*z).InnerTxns[zb0004].UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "InnerTxns", zb0004)
					return
				}
			}
		}
		if zb0005 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0005)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0006 {
			(*z) = EvalDelta{}
		}
		for zb0005 > 0 {
			zb0005--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "gd":
				bts, err = (*z).GlobalDelta.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "GlobalDelta")
					return
				}
			case "ld":
				var zb0013 int
				var zb0014 bool
				zb0013, zb0014, bts, err = msgp.ReadMapHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "LocalDeltas")
					return
				}
				if zb0013 > config.MaxEvalDeltaAccounts {
					err = msgp.ErrOverflow(uint64(zb0013), uint64(config.MaxEvalDeltaAccounts))
					err = msgp.WrapError(err, "LocalDeltas")
					return
				}
				if zb0014 {
					(*z).LocalDeltas = nil
				} else if (*z).LocalDeltas == nil {
					(*z).LocalDeltas = make(map[uint64]basics.StateDelta, zb0013)
				}
				for zb0013 > 0 {
					var zb0001 uint64
					var zb0002 basics.StateDelta
					zb0013--
					zb0001, bts, err = msgp.ReadUint64Bytes(bts)
					if err != nil {
						err = msgp.WrapError(err, "LocalDeltas")
						return
					}
					bts, err = zb0002.UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "LocalDeltas", zb0001)
						return
					}
					(*z).LocalDeltas[zb0001] = zb0002
				}
			case "lg":
				var zb0015 int
				var zb0016 bool
				zb0015, zb0016, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "Logs")
					return
				}
				if zb0015 > config.MaxLogCalls {
					err = msgp.ErrOverflow(uint64(zb0015), uint64(config.MaxLogCalls))
					err = msgp.WrapError(err, "Logs")
					return
				}
				if zb0016 {
					(*z).Logs = nil
				} else if (*z).Logs != nil && cap((*z).Logs) >= zb0015 {
					(*z).Logs = ((*z).Logs)[:zb0015]
				} else {
					(*z).Logs = make([]string, zb0015)
				}
				for zb0003 := range (*z).Logs {
					(*z).Logs[zb0003], bts, err = msgp.ReadStringBytes(bts)
					if err != nil {
						err = msgp.WrapError(err, "Logs", zb0003)
						return
					}
				}
			case "itx":
				var zb0017 int
				var zb0018 bool
				zb0017, zb0018, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "InnerTxns")
					return
				}
				if zb0017 > config.MaxInnerTransactionsPerDelta {
					err = msgp.ErrOverflow(uint64(zb0017), uint64(config.MaxInnerTransactionsPerDelta))
					err = msgp.WrapError(err, "InnerTxns")
					return
				}
				if zb0018 {
					(*z).InnerTxns = nil
				} else if (*z).InnerTxns != nil && cap((*z).InnerTxns) >= zb0017 {
					(*z).InnerTxns = ((*z).InnerTxns)[:zb0017]
				} else {
					(*z).InnerTxns = make([]SignedTxnWithAD, zb0017)
				}
				for zb0004 := range (*z).InnerTxns {
					bts, err = (*z).InnerTxns[zb0004].UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "InnerTxns", zb0004)
						return
					}
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *EvalDelta) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*EvalDelta)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *EvalDelta) Msgsize() (s int) {
	s = 1 + 3 + (*z).GlobalDelta.Msgsize() + 3 + msgp.MapHeaderSize
	if (*z).LocalDeltas != nil {
		for zb0001, zb0002 := range (*z).LocalDeltas {
			_ = zb0001
			_ = zb0002
			s += 0 + msgp.Uint64Size + zb0002.Msgsize()
		}
	}
	s += 3 + msgp.ArrayHeaderSize
	for zb0003 := range (*z).Logs {
		s += msgp.StringPrefixSize + len((*z).Logs[zb0003])
	}
	s += 4 + msgp.ArrayHeaderSize
	for zb0004 := range (*z).InnerTxns {
		s += (*z).InnerTxns[zb0004].Msgsize()
	}
	return
}

// MsgIsZero returns whether this is a zero value
func (z *EvalDelta) MsgIsZero() bool {
	return ((*z).GlobalDelta.MsgIsZero()) && (len((*z).LocalDeltas) == 0) && (len((*z).Logs) == 0) && (len((*z).InnerTxns) == 0)
}

// MarshalMsg implements msgp.Marshaler
func (z *Header) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0002Len := uint32(10)
	var zb0002Mask uint16 /* 11 bits */
	if (*z).Fee.MsgIsZero() {
		zb0002Len--
		zb0002Mask |= 0x2
	}
	if (*z).FirstValid.MsgIsZero() {
		zb0002Len--
		zb0002Mask |= 0x4
	}
	if (*z).GenesisID == "" {
		zb0002Len--
		zb0002Mask |= 0x8
	}
	if (*z).GenesisHash.MsgIsZero() {
		zb0002Len--
		zb0002Mask |= 0x10
	}
	if (*z).Group.MsgIsZero() {
		zb0002Len--
		zb0002Mask |= 0x20
	}
	if (*z).LastValid.MsgIsZero() {
		zb0002Len--
		zb0002Mask |= 0x40
	}
	if (*z).Lease == ([32]byte{}) {
		zb0002Len--
		zb0002Mask |= 0x80
	}
	if len((*z).Note) == 0 {
		zb0002Len--
		zb0002Mask |= 0x100
	}
	if (*z).RekeyTo.MsgIsZero() {
		zb0002Len--
		zb0002Mask |= 0x200
	}
	if (*z).Sender.MsgIsZero() {
		zb0002Len--
		zb0002Mask |= 0x400
	}
	// variable map header, size zb0002Len
	o = append(o, 0x80|uint8(zb0002Len))
	if zb0002Len != 0 {
		if (zb0002Mask & 0x2) == 0 { // if not empty
			// string "fee"
			o = append(o, 0xa3, 0x66, 0x65, 0x65)
			o = (*z).Fee.MarshalMsg(o)
		}
		if (zb0002Mask & 0x4) == 0 { // if not empty
			// string "fv"
			o = append(o, 0xa2, 0x66, 0x76)
			o = (*z).FirstValid.MarshalMsg(o)
		}
		if (zb0002Mask & 0x8) == 0 { // if not empty
			// string "gen"
			o = append(o, 0xa3, 0x67, 0x65, 0x6e)
			o = msgp.AppendString(o, (*z).GenesisID)
		}
		if (zb0002Mask & 0x10) == 0 { // if not empty
			// string "gh"
			o = append(o, 0xa2, 0x67, 0x68)
			o = (*z).GenesisHash.MarshalMsg(o)
		}
		if (zb0002Mask & 0x20) == 0 { // if not empty
			// string "grp"
			o = append(o, 0xa3, 0x67, 0x72, 0x70)
			o = (*z).Group.MarshalMsg(o)
		}
		if (zb0002Mask & 0x40) == 0 { // if not empty
			// string "lv"
			o = append(o, 0xa2, 0x6c, 0x76)
			o = (*z).LastValid.MarshalMsg(o)
		}
		if (zb0002Mask & 0x80) == 0 { // if not empty
			// string "lx"
			o = append(o, 0xa2, 0x6c, 0x78)
			o = msgp.AppendBytes(o, ((*z).Lease)[:])
		}
		if (zb0002Mask & 0x100) == 0 { // if not empty
			// string "note"
			o = append(o, 0xa4, 0x6e, 0x6f, 0x74, 0x65)
			o = msgp.AppendBytes(o, (*z).Note)
		}
		if (zb0002Mask & 0x200) == 0 { // if not empty
			// string "rekey"
			o = append(o, 0xa5, 0x72, 0x65, 0x6b, 0x65, 0x79)
			o = (*z).RekeyTo.MarshalMsg(o)
		}
		if (zb0002Mask & 0x400) == 0 { // if not empty
			// string "snd"
			o = append(o, 0xa3, 0x73, 0x6e, 0x64)
			o = (*z).Sender.MarshalMsg(o)
		}
	}
	return
}

func (_ *Header) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*Header)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *Header) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0002 int
	var zb0003 bool
	zb0002, zb0003, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0002, zb0003, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = (*z).Sender.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Sender")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = (*z).Fee.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Fee")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = (*z).FirstValid.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "FirstValid")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = (*z).LastValid.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "LastValid")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			var zb0004 int
			zb0004, err = msgp.ReadBytesBytesHeader(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Note")
				return
			}
			if zb0004 > config.MaxTxnNoteBytes {
				err = msgp.ErrOverflow(uint64(zb0004), uint64(config.MaxTxnNoteBytes))
				return
			}
			(*z).Note, bts, err = msgp.ReadBytesBytes(bts, (*z).Note)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Note")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			(*z).GenesisID, bts, err = msgp.ReadStringBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "GenesisID")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = (*z).GenesisHash.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "GenesisHash")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = (*z).Group.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Group")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = msgp.ReadExactBytes(bts, ((*z).Lease)[:])
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Lease")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = (*z).RekeyTo.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "RekeyTo")
				return
			}
		}
		if zb0002 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0002)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0003 {
			(*z) = Header{}
		}
		for zb0002 > 0 {
			zb0002--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "snd":
				bts, err = (*z).Sender.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Sender")
					return
				}
			case "fee":
				bts, err = (*z).Fee.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Fee")
					return
				}
			case "fv":
				bts, err = (*z).FirstValid.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "FirstValid")
					return
				}
			case "lv":
				bts, err = (*z).LastValid.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "LastValid")
					return
				}
			case "note":
				var zb0005 int
				zb0005, err = msgp.ReadBytesBytesHeader(bts)
				if err != nil {
					err = msgp.WrapError(err, "Note")
					return
				}
				if zb0005 > config.MaxTxnNoteBytes {
					err = msgp.ErrOverflow(uint64(zb0005), uint64(config.MaxTxnNoteBytes))
					return
				}
				(*z).Note, bts, err = msgp.ReadBytesBytes(bts, (*z).Note)
				if err != nil {
					err = msgp.WrapError(err, "Note")
					return
				}
			case "gen":
				(*z).GenesisID, bts, err = msgp.ReadStringBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "GenesisID")
					return
				}
			case "gh":
				bts, err = (*z).GenesisHash.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "GenesisHash")
					return
				}
			case "grp":
				bts, err = (*z).Group.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Group")
					return
				}
			case "lx":
				bts, err = msgp.ReadExactBytes(bts, ((*z).Lease)[:])
				if err != nil {
					err = msgp.WrapError(err, "Lease")
					return
				}
			case "rekey":
				bts, err = (*z).RekeyTo.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "RekeyTo")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *Header) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*Header)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *Header) Msgsize() (s int) {
	s = 1 + 4 + (*z).Sender.Msgsize() + 4 + (*z).Fee.Msgsize() + 3 + (*z).FirstValid.Msgsize() + 3 + (*z).LastValid.Msgsize() + 5 + msgp.BytesPrefixSize + len((*z).Note) + 4 + msgp.StringPrefixSize + len((*z).GenesisID) + 3 + (*z).GenesisHash.Msgsize() + 4 + (*z).Group.Msgsize() + 3 + msgp.ArrayHeaderSize + (32 * (msgp.ByteSize)) + 6 + (*z).RekeyTo.Msgsize()
	return
}

// MsgIsZero returns whether this is a zero value
func (z *Header) MsgIsZero() bool {
	return ((*z).Sender.MsgIsZero()) && ((*z).Fee.MsgIsZero()) && ((*z).FirstValid.MsgIsZero()) && ((*z).LastValid.MsgIsZero()) && (len((*z).Note) == 0) && ((*z).GenesisID == "") && ((*z).GenesisHash.MsgIsZero()) && ((*z).Group.MsgIsZero()) && ((*z).Lease == ([32]byte{})) && ((*z).RekeyTo.MsgIsZero())
}

// MarshalMsg implements msgp.Marshaler
func (z *KeyregTxnFields) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(7)
	var zb0001Mask uint8 /* 8 bits */
	if (*z).Nonparticipation == false {
		zb0001Len--
		zb0001Mask |= 0x2
	}
	if (*z).SelectionPK.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4
	}
	if (*z).StateProofPK.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x8
	}
	if (*z).VoteFirst.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x10
	}
	if (*z).VoteKeyDilution == 0 {
		zb0001Len--
		zb0001Mask |= 0x20
	}
	if (*z).VotePK.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x40
	}
	if (*z).VoteLast.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x80
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x2) == 0 { // if not empty
			// string "nonpart"
			o = append(o, 0xa7, 0x6e, 0x6f, 0x6e, 0x70, 0x61, 0x72, 0x74)
			o = msgp.AppendBool(o, (*z).Nonparticipation)
		}
		if (zb0001Mask & 0x4) == 0 { // if not empty
			// string "selkey"
			o = append(o, 0xa6, 0x73, 0x65, 0x6c, 0x6b, 0x65, 0x79)
			o = (*z).SelectionPK.MarshalMsg(o)
		}
		if (zb0001Mask & 0x8) == 0 { // if not empty
			// string "sprfkey"
			o = append(o, 0xa7, 0x73, 0x70, 0x72, 0x66, 0x6b, 0x65, 0x79)
			o = (*z).StateProofPK.MarshalMsg(o)
		}
		if (zb0001Mask & 0x10) == 0 { // if not empty
			// string "votefst"
			o = append(o, 0xa7, 0x76, 0x6f, 0x74, 0x65, 0x66, 0x73, 0x74)
			o = (*z).VoteFirst.MarshalMsg(o)
		}
		if (zb0001Mask & 0x20) == 0 { // if not empty
			// string "votekd"
			o = append(o, 0xa6, 0x76, 0x6f, 0x74, 0x65, 0x6b, 0x64)
			o = msgp.AppendUint64(o, (*z).VoteKeyDilution)
		}
		if (zb0001Mask & 0x40) == 0 { // if not empty
			// string "votekey"
			o = append(o, 0xa7, 0x76, 0x6f, 0x74, 0x65, 0x6b, 0x65, 0x79)
			o = (*z).VotePK.MarshalMsg(o)
		}
		if (zb0001Mask & 0x80) == 0 { // if not empty
			// string "votelst"
			o = append(o, 0xa7, 0x76, 0x6f, 0x74, 0x65, 0x6c, 0x73, 0x74)
			o = (*z).VoteLast.MarshalMsg(o)
		}
	}
	return
}

func (_ *KeyregTxnFields) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*KeyregTxnFields)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *KeyregTxnFields) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).VotePK.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "VotePK")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SelectionPK.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "SelectionPK")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).StateProofPK.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "StateProofPK")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).VoteFirst.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "VoteFirst")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).VoteLast.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "VoteLast")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			(*z).VoteKeyDilution, bts, err = msgp.ReadUint64Bytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "VoteKeyDilution")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			(*z).Nonparticipation, bts, err = msgp.ReadBoolBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Nonparticipation")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = KeyregTxnFields{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "votekey":
				bts, err = (*z).VotePK.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "VotePK")
					return
				}
			case "selkey":
				bts, err = (*z).SelectionPK.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "SelectionPK")
					return
				}
			case "sprfkey":
				bts, err = (*z).StateProofPK.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "StateProofPK")
					return
				}
			case "votefst":
				bts, err = (*z).VoteFirst.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "VoteFirst")
					return
				}
			case "votelst":
				bts, err = (*z).VoteLast.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "VoteLast")
					return
				}
			case "votekd":
				(*z).VoteKeyDilution, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "VoteKeyDilution")
					return
				}
			case "nonpart":
				(*z).Nonparticipation, bts, err = msgp.ReadBoolBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "Nonparticipation")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *KeyregTxnFields) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*KeyregTxnFields)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *KeyregTxnFields) Msgsize() (s int) {
	s = 1 + 8 + (*z).VotePK.Msgsize() + 7 + (*z).SelectionPK.Msgsize() + 8 + (*z).StateProofPK.Msgsize() + 8 + (*z).VoteFirst.Msgsize() + 8 + (*z).VoteLast.Msgsize() + 7 + msgp.Uint64Size + 8 + msgp.BoolSize
	return
}

// MsgIsZero returns whether this is a zero value
func (z *KeyregTxnFields) MsgIsZero() bool {
	return ((*z).VotePK.MsgIsZero()) && ((*z).SelectionPK.MsgIsZero()) && ((*z).StateProofPK.MsgIsZero()) && ((*z).VoteFirst.MsgIsZero()) && ((*z).VoteLast.MsgIsZero()) && ((*z).VoteKeyDilution == 0) && ((*z).Nonparticipation == false)
}

// MarshalMsg implements msgp.Marshaler
func (z *LogicSig) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0002Len := uint32(4)
	var zb0002Mask uint8 /* 5 bits */
	if len((*z).Args) == 0 {
		zb0002Len--
		zb0002Mask |= 0x2
	}
	if len((*z).Logic) == 0 {
		zb0002Len--
		zb0002Mask |= 0x4
	}
	if (*z).Msig.MsgIsZero() {
		zb0002Len--
		zb0002Mask |= 0x8
	}
	if (*z).Sig.MsgIsZero() {
		zb0002Len--
		zb0002Mask |= 0x10
	}
	// variable map header, size zb0002Len
	o = append(o, 0x80|uint8(zb0002Len))
	if zb0002Len != 0 {
		if (zb0002Mask & 0x2) == 0 { // if not empty
			// string "arg"
			o = append(o, 0xa3, 0x61, 0x72, 0x67)
			if (*z).Args == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).Args)))
			}
			for zb0001 := range (*z).Args {
				o = msgp.AppendBytes(o, (*z).Args[zb0001])
			}
		}
		if (zb0002Mask & 0x4) == 0 { // if not empty
			// string "l"
			o = append(o, 0xa1, 0x6c)
			o = msgp.AppendBytes(o, (*z).Logic)
		}
		if (zb0002Mask & 0x8) == 0 { // if not empty
			// string "msig"
			o = append(o, 0xa4, 0x6d, 0x73, 0x69, 0x67)
			o = (*z).Msig.MarshalMsg(o)
		}
		if (zb0002Mask & 0x10) == 0 { // if not empty
			// string "sig"
			o = append(o, 0xa3, 0x73, 0x69, 0x67)
			o = (*z).Sig.MarshalMsg(o)
		}
	}
	return
}

func (_ *LogicSig) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*LogicSig)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *LogicSig) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0002 int
	var zb0003 bool
	zb0002, zb0003, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0002, zb0003, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 > 0 {
			zb0002--
			var zb0004 int
			zb0004, err = msgp.ReadBytesBytesHeader(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Logic")
				return
			}
			if zb0004 > config.MaxLogicSigMaxSize {
				err = msgp.ErrOverflow(uint64(zb0004), uint64(config.MaxLogicSigMaxSize))
				return
			}
			(*z).Logic, bts, err = msgp.ReadBytesBytes(bts, (*z).Logic)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Logic")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = (*z).Sig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Sig")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			bts, err = (*z).Msig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Msig")
				return
			}
		}
		if zb0002 > 0 {
			zb0002--
			var zb0005 int
			var zb0006 bool
			zb0005, zb0006, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Args")
				return
			}
			if zb0005 > EvalMaxArgs {
				err = msgp.ErrOverflow(uint64(zb0005), uint64(EvalMaxArgs))
				err = msgp.WrapError(err, "struct-from-array", "Args")
				return
			}
			if zb0006 {
				(*z).Args = nil
			} else if (*z).Args != nil && cap((*z).Args) >= zb0005 {
				(*z).Args = ((*z).Args)[:zb0005]
			} else {
				(*z).Args = make([][]byte, zb0005)
			}
			for zb0001 := range (*z).Args {
				var zb0007 int
				zb0007, err = msgp.ReadBytesBytesHeader(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "Args", zb0001)
					return
				}
				if zb0007 > config.MaxLogicSigMaxSize {
					err = msgp.ErrOverflow(uint64(zb0007), uint64(config.MaxLogicSigMaxSize))
					return
				}
				(*z).Args[zb0001], bts, err = msgp.ReadBytesBytes(bts, (*z).Args[zb0001])
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "Args", zb0001)
					return
				}
			}
		}
		if zb0002 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0002)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0003 {
			(*z) = LogicSig{}
		}
		for zb0002 > 0 {
			zb0002--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "l":
				var zb0008 int
				zb0008, err = msgp.ReadBytesBytesHeader(bts)
				if err != nil {
					err = msgp.WrapError(err, "Logic")
					return
				}
				if zb0008 > config.MaxLogicSigMaxSize {
					err = msgp.ErrOverflow(uint64(zb0008), uint64(config.MaxLogicSigMaxSize))
					return
				}
				(*z).Logic, bts, err = msgp.ReadBytesBytes(bts, (*z).Logic)
				if err != nil {
					err = msgp.WrapError(err, "Logic")
					return
				}
			case "sig":
				bts, err = (*z).Sig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Sig")
					return
				}
			case "msig":
				bts, err = (*z).Msig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Msig")
					return
				}
			case "arg":
				var zb0009 int
				var zb0010 bool
				zb0009, zb0010, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "Args")
					return
				}
				if zb0009 > EvalMaxArgs {
					err = msgp.ErrOverflow(uint64(zb0009), uint64(EvalMaxArgs))
					err = msgp.WrapError(err, "Args")
					return
				}
				if zb0010 {
					(*z).Args = nil
				} else if (*z).Args != nil && cap((*z).Args) >= zb0009 {
					(*z).Args = ((*z).Args)[:zb0009]
				} else {
					(*z).Args = make([][]byte, zb0009)
				}
				for zb0001 := range (*z).Args {
					var zb0011 int
					zb0011, err = msgp.ReadBytesBytesHeader(bts)
					if err != nil {
						err = msgp.WrapError(err, "Args", zb0001)
						return
					}
					if zb0011 > config.MaxLogicSigMaxSize {
						err = msgp.ErrOverflow(uint64(zb0011), uint64(config.MaxLogicSigMaxSize))
						return
					}
					(*z).Args[zb0001], bts, err = msgp.ReadBytesBytes(bts, (*z).Args[zb0001])
					if err != nil {
						err = msgp.WrapError(err, "Args", zb0001)
						return
					}
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *LogicSig) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*LogicSig)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *LogicSig) Msgsize() (s int) {
	s = 1 + 2 + msgp.BytesPrefixSize + len((*z).Logic) + 4 + (*z).Sig.Msgsize() + 5 + (*z).Msig.Msgsize() + 4 + msgp.ArrayHeaderSize
	for zb0001 := range (*z).Args {
		s += msgp.BytesPrefixSize + len((*z).Args[zb0001])
	}
	return
}

// MsgIsZero returns whether this is a zero value
func (z *LogicSig) MsgIsZero() bool {
	return (len((*z).Logic) == 0) && ((*z).Sig.MsgIsZero()) && ((*z).Msig.MsgIsZero()) && (len((*z).Args) == 0)
}

// MarshalMsg implements msgp.Marshaler
func (z MinFeeError) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	o = msgp.AppendString(o, string(z))
	return
}

func (_ MinFeeError) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(MinFeeError)
	if !ok {
		_, ok = (z).(*MinFeeError)
	}
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *MinFeeError) UnmarshalMsg(bts []byte) (o []byte, err error) {
	{
		var zb0001 string
		zb0001, bts, err = msgp.ReadStringBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		(*z) = MinFeeError(zb0001)
	}
	o = bts
	return
}

func (_ *MinFeeError) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*MinFeeError)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z MinFeeError) Msgsize() (s int) {
	s = msgp.StringPrefixSize + len(string(z))
	return
}

// MsgIsZero returns whether this is a zero value
func (z MinFeeError) MsgIsZero() bool {
	return z == ""
}

// MarshalMsg implements msgp.Marshaler
func (z OnCompletion) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	o = msgp.AppendUint64(o, uint64(z))
	return
}

func (_ OnCompletion) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(OnCompletion)
	if !ok {
		_, ok = (z).(*OnCompletion)
	}
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *OnCompletion) UnmarshalMsg(bts []byte) (o []byte, err error) {
	{
		var zb0001 uint64
		zb0001, bts, err = msgp.ReadUint64Bytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		(*z) = OnCompletion(zb0001)
	}
	o = bts
	return
}

func (_ *OnCompletion) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*OnCompletion)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z OnCompletion) Msgsize() (s int) {
	s = msgp.Uint64Size
	return
}

// MsgIsZero returns whether this is a zero value
func (z OnCompletion) MsgIsZero() bool {
	return z == 0
}

// MarshalMsg implements msgp.Marshaler
func (z *PaymentTxnFields) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(3)
	var zb0001Mask uint8 /* 4 bits */
	if (*z).Amount.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x2
	}
	if (*z).CloseRemainderTo.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4
	}
	if (*z).Receiver.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x8
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x2) == 0 { // if not empty
			// string "amt"
			o = append(o, 0xa3, 0x61, 0x6d, 0x74)
			o = (*z).Amount.MarshalMsg(o)
		}
		if (zb0001Mask & 0x4) == 0 { // if not empty
			// string "close"
			o = append(o, 0xa5, 0x63, 0x6c, 0x6f, 0x73, 0x65)
			o = (*z).CloseRemainderTo.MarshalMsg(o)
		}
		if (zb0001Mask & 0x8) == 0 { // if not empty
			// string "rcv"
			o = append(o, 0xa3, 0x72, 0x63, 0x76)
			o = (*z).Receiver.MarshalMsg(o)
		}
	}
	return
}

func (_ *PaymentTxnFields) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*PaymentTxnFields)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *PaymentTxnFields) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).Receiver.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Receiver")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).Amount.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Amount")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).CloseRemainderTo.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "CloseRemainderTo")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = PaymentTxnFields{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "rcv":
				bts, err = (*z).Receiver.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Receiver")
					return
				}
			case "amt":
				bts, err = (*z).Amount.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Amount")
					return
				}
			case "close":
				bts, err = (*z).CloseRemainderTo.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "CloseRemainderTo")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *PaymentTxnFields) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*PaymentTxnFields)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *PaymentTxnFields) Msgsize() (s int) {
	s = 1 + 4 + (*z).Receiver.Msgsize() + 4 + (*z).Amount.Msgsize() + 6 + (*z).CloseRemainderTo.Msgsize()
	return
}

// MsgIsZero returns whether this is a zero value
func (z *PaymentTxnFields) MsgIsZero() bool {
	return ((*z).Receiver.MsgIsZero()) && ((*z).Amount.MsgIsZero()) && ((*z).CloseRemainderTo.MsgIsZero())
}

// MarshalMsg implements msgp.Marshaler
func (z Payset) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	if z == nil {
		o = msgp.AppendNil(o)
	} else {
		o = msgp.AppendArrayHeader(o, uint32(len(z)))
	}
	for za0001 := range z {
		o = z[za0001].MarshalMsg(o)
	}
	return
}

func (_ Payset) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(Payset)
	if !ok {
		_, ok = (z).(*Payset)
	}
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *Payset) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var zb0002 int
	var zb0003 bool
	zb0002, zb0003, bts, err = msgp.ReadArrayHeaderBytes(bts)
	if err != nil {
		err = msgp.WrapError(err)
		return
	}
	if zb0002 > 100000 {
		err = msgp.ErrOverflow(uint64(zb0002), uint64(100000))
		err = msgp.WrapError(err)
		return
	}
	if zb0003 {
		(*z) = nil
	} else if (*z) != nil && cap((*z)) >= zb0002 {
		(*z) = (*z)[:zb0002]
	} else {
		(*z) = make(Payset, zb0002)
	}
	for zb0001 := range *z {
		bts, err = (*z)[zb0001].UnmarshalMsg(bts)
		if err != nil {
			err = msgp.WrapError(err, zb0001)
			return
		}
	}
	o = bts
	return
}

func (_ *Payset) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*Payset)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z Payset) Msgsize() (s int) {
	s = msgp.ArrayHeaderSize
	for za0001 := range z {
		s += z[za0001].Msgsize()
	}
	return
}

// MsgIsZero returns whether this is a zero value
func (z Payset) MsgIsZero() bool {
	return len(z) == 0
}

// MarshalMsg implements msgp.Marshaler
func (z *SignedTxn) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(5)
	var zb0001Mask uint8 /* 6 bits */
	if (*z).Lsig.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x2
	}
	if (*z).Msig.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4
	}
	if (*z).AuthAddr.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x8
	}
	if (*z).Sig.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x10
	}
	if (*z).Txn.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x20
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x2) == 0 { // if not empty
			// string "lsig"
			o = append(o, 0xa4, 0x6c, 0x73, 0x69, 0x67)
			o = (*z).Lsig.MarshalMsg(o)
		}
		if (zb0001Mask & 0x4) == 0 { // if not empty
			// string "msig"
			o = append(o, 0xa4, 0x6d, 0x73, 0x69, 0x67)
			o = (*z).Msig.MarshalMsg(o)
		}
		if (zb0001Mask & 0x8) == 0 { // if not empty
			// string "sgnr"
			o = append(o, 0xa4, 0x73, 0x67, 0x6e, 0x72)
			o = (*z).AuthAddr.MarshalMsg(o)
		}
		if (zb0001Mask & 0x10) == 0 { // if not empty
			// string "sig"
			o = append(o, 0xa3, 0x73, 0x69, 0x67)
			o = (*z).Sig.MarshalMsg(o)
		}
		if (zb0001Mask & 0x20) == 0 { // if not empty
			// string "txn"
			o = append(o, 0xa3, 0x74, 0x78, 0x6e)
			o = (*z).Txn.MarshalMsg(o)
		}
	}
	return
}

func (_ *SignedTxn) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*SignedTxn)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *SignedTxn) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).Sig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Sig")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).Msig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Msig")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).Lsig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Lsig")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).Txn.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Txn")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).AuthAddr.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AuthAddr")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = SignedTxn{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "sig":
				bts, err = (*z).Sig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Sig")
					return
				}
			case "msig":
				bts, err = (*z).Msig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Msig")
					return
				}
			case "lsig":
				bts, err = (*z).Lsig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Lsig")
					return
				}
			case "txn":
				bts, err = (*z).Txn.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Txn")
					return
				}
			case "sgnr":
				bts, err = (*z).AuthAddr.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AuthAddr")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *SignedTxn) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*SignedTxn)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *SignedTxn) Msgsize() (s int) {
	s = 1 + 4 + (*z).Sig.Msgsize() + 5 + (*z).Msig.Msgsize() + 5 + (*z).Lsig.Msgsize() + 4 + (*z).Txn.Msgsize() + 5 + (*z).AuthAddr.Msgsize()
	return
}

// MsgIsZero returns whether this is a zero value
func (z *SignedTxn) MsgIsZero() bool {
	return ((*z).Sig.MsgIsZero()) && ((*z).Msig.MsgIsZero()) && ((*z).Lsig.MsgIsZero()) && ((*z).Txn.MsgIsZero()) && ((*z).AuthAddr.MsgIsZero())
}

// MarshalMsg implements msgp.Marshaler
func (z *SignedTxnInBlock) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(15)
	var zb0001Mask uint32 /* 19 bits */
	if (*z).SignedTxnWithAD.ApplyData.AssetClosingAmount == 0 {
		zb0001Len--
		zb0001Mask |= 0x10
	}
	if (*z).SignedTxnWithAD.ApplyData.ApplicationID.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x20
	}
	if (*z).SignedTxnWithAD.ApplyData.ClosingAmount.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x40
	}
	if (*z).SignedTxnWithAD.ApplyData.ConfigAsset.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x80
	}
	if (*z).SignedTxnWithAD.ApplyData.EvalDelta.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x100
	}
	if (*z).HasGenesisHash == false {
		zb0001Len--
		zb0001Mask |= 0x200
	}
	if (*z).HasGenesisID == false {
		zb0001Len--
		zb0001Mask |= 0x400
	}
	if (*z).SignedTxnWithAD.SignedTxn.Lsig.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x800
	}
	if (*z).SignedTxnWithAD.SignedTxn.Msig.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x1000
	}
	if (*z).SignedTxnWithAD.ApplyData.CloseRewards.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x2000
	}
	if (*z).SignedTxnWithAD.ApplyData.ReceiverRewards.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4000
	}
	if (*z).SignedTxnWithAD.ApplyData.SenderRewards.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x8000
	}
	if (*z).SignedTxnWithAD.SignedTxn.AuthAddr.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x10000
	}
	if (*z).SignedTxnWithAD.SignedTxn.Sig.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x20000
	}
	if (*z).SignedTxnWithAD.SignedTxn.Txn.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x40000
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x10) == 0 { // if not empty
			// string "aca"
			o = append(o, 0xa3, 0x61, 0x63, 0x61)
			o = msgp.AppendUint64(o, (*z).SignedTxnWithAD.ApplyData.AssetClosingAmount)
		}
		if (zb0001Mask & 0x20) == 0 { // if not empty
			// string "apid"
			o = append(o, 0xa4, 0x61, 0x70, 0x69, 0x64)
			o = (*z).SignedTxnWithAD.ApplyData.ApplicationID.MarshalMsg(o)
		}
		if (zb0001Mask & 0x40) == 0 { // if not empty
			// string "ca"
			o = append(o, 0xa2, 0x63, 0x61)
			o = (*z).SignedTxnWithAD.ApplyData.ClosingAmount.MarshalMsg(o)
		}
		if (zb0001Mask & 0x80) == 0 { // if not empty
			// string "caid"
			o = append(o, 0xa4, 0x63, 0x61, 0x69, 0x64)
			o = (*z).SignedTxnWithAD.ApplyData.ConfigAsset.MarshalMsg(o)
		}
		if (zb0001Mask & 0x100) == 0 { // if not empty
			// string "dt"
			o = append(o, 0xa2, 0x64, 0x74)
			o = (*z).SignedTxnWithAD.ApplyData.EvalDelta.MarshalMsg(o)
		}
		if (zb0001Mask & 0x200) == 0 { // if not empty
			// string "hgh"
			o = append(o, 0xa3, 0x68, 0x67, 0x68)
			o = msgp.AppendBool(o, (*z).HasGenesisHash)
		}
		if (zb0001Mask & 0x400) == 0 { // if not empty
			// string "hgi"
			o = append(o, 0xa3, 0x68, 0x67, 0x69)
			o = msgp.AppendBool(o, (*z).HasGenesisID)
		}
		if (zb0001Mask & 0x800) == 0 { // if not empty
			// string "lsig"
			o = append(o, 0xa4, 0x6c, 0x73, 0x69, 0x67)
			o = (*z).SignedTxnWithAD.SignedTxn.Lsig.MarshalMsg(o)
		}
		if (zb0001Mask & 0x1000) == 0 { // if not empty
			// string "msig"
			o = append(o, 0xa4, 0x6d, 0x73, 0x69, 0x67)
			o = (*z).SignedTxnWithAD.SignedTxn.Msig.MarshalMsg(o)
		}
		if (zb0001Mask & 0x2000) == 0 { // if not empty
			// string "rc"
			o = append(o, 0xa2, 0x72, 0x63)
			o = (*z).SignedTxnWithAD.ApplyData.CloseRewards.MarshalMsg(o)
		}
		if (zb0001Mask & 0x4000) == 0 { // if not empty
			// string "rr"
			o = append(o, 0xa2, 0x72, 0x72)
			o = (*z).SignedTxnWithAD.ApplyData.ReceiverRewards.MarshalMsg(o)
		}
		if (zb0001Mask & 0x8000) == 0 { // if not empty
			// string "rs"
			o = append(o, 0xa2, 0x72, 0x73)
			o = (*z).SignedTxnWithAD.ApplyData.SenderRewards.MarshalMsg(o)
		}
		if (zb0001Mask & 0x10000) == 0 { // if not empty
			// string "sgnr"
			o = append(o, 0xa4, 0x73, 0x67, 0x6e, 0x72)
			o = (*z).SignedTxnWithAD.SignedTxn.AuthAddr.MarshalMsg(o)
		}
		if (zb0001Mask & 0x20000) == 0 { // if not empty
			// string "sig"
			o = append(o, 0xa3, 0x73, 0x69, 0x67)
			o = (*z).SignedTxnWithAD.SignedTxn.Sig.MarshalMsg(o)
		}
		if (zb0001Mask & 0x40000) == 0 { // if not empty
			// string "txn"
			o = append(o, 0xa3, 0x74, 0x78, 0x6e)
			o = (*z).SignedTxnWithAD.SignedTxn.Txn.MarshalMsg(o)
		}
	}
	return
}

func (_ *SignedTxnInBlock) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*SignedTxnInBlock)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *SignedTxnInBlock) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.SignedTxn.Sig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Sig")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.SignedTxn.Msig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Msig")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.SignedTxn.Lsig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Lsig")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.SignedTxn.Txn.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Txn")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.SignedTxn.AuthAddr.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AuthAddr")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.ApplyData.ClosingAmount.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ClosingAmount")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			(*z).SignedTxnWithAD.ApplyData.AssetClosingAmount, bts, err = msgp.ReadUint64Bytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetClosingAmount")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.ApplyData.SenderRewards.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "SenderRewards")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.ApplyData.ReceiverRewards.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ReceiverRewards")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.ApplyData.CloseRewards.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "CloseRewards")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.ApplyData.EvalDelta.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "EvalDelta")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.ApplyData.ConfigAsset.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ConfigAsset")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxnWithAD.ApplyData.ApplicationID.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApplicationID")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			(*z).HasGenesisID, bts, err = msgp.ReadBoolBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "HasGenesisID")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			(*z).HasGenesisHash, bts, err = msgp.ReadBoolBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "HasGenesisHash")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = SignedTxnInBlock{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "sig":
				bts, err = (*z).SignedTxnWithAD.SignedTxn.Sig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Sig")
					return
				}
			case "msig":
				bts, err = (*z).SignedTxnWithAD.SignedTxn.Msig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Msig")
					return
				}
			case "lsig":
				bts, err = (*z).SignedTxnWithAD.SignedTxn.Lsig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Lsig")
					return
				}
			case "txn":
				bts, err = (*z).SignedTxnWithAD.SignedTxn.Txn.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Txn")
					return
				}
			case "sgnr":
				bts, err = (*z).SignedTxnWithAD.SignedTxn.AuthAddr.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AuthAddr")
					return
				}
			case "ca":
				bts, err = (*z).SignedTxnWithAD.ApplyData.ClosingAmount.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ClosingAmount")
					return
				}
			case "aca":
				(*z).SignedTxnWithAD.ApplyData.AssetClosingAmount, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetClosingAmount")
					return
				}
			case "rs":
				bts, err = (*z).SignedTxnWithAD.ApplyData.SenderRewards.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "SenderRewards")
					return
				}
			case "rr":
				bts, err = (*z).SignedTxnWithAD.ApplyData.ReceiverRewards.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ReceiverRewards")
					return
				}
			case "rc":
				bts, err = (*z).SignedTxnWithAD.ApplyData.CloseRewards.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "CloseRewards")
					return
				}
			case "dt":
				bts, err = (*z).SignedTxnWithAD.ApplyData.EvalDelta.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "EvalDelta")
					return
				}
			case "caid":
				bts, err = (*z).SignedTxnWithAD.ApplyData.ConfigAsset.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ConfigAsset")
					return
				}
			case "apid":
				bts, err = (*z).SignedTxnWithAD.ApplyData.ApplicationID.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ApplicationID")
					return
				}
			case "hgi":
				(*z).HasGenesisID, bts, err = msgp.ReadBoolBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "HasGenesisID")
					return
				}
			case "hgh":
				(*z).HasGenesisHash, bts, err = msgp.ReadBoolBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "HasGenesisHash")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *SignedTxnInBlock) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*SignedTxnInBlock)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *SignedTxnInBlock) Msgsize() (s int) {
	s = 1 + 4 + (*z).SignedTxnWithAD.SignedTxn.Sig.Msgsize() + 5 + (*z).SignedTxnWithAD.SignedTxn.Msig.Msgsize() + 5 + (*z).SignedTxnWithAD.SignedTxn.Lsig.Msgsize() + 4 + (*z).SignedTxnWithAD.SignedTxn.Txn.Msgsize() + 5 + (*z).SignedTxnWithAD.SignedTxn.AuthAddr.Msgsize() + 3 + (*z).SignedTxnWithAD.ApplyData.ClosingAmount.Msgsize() + 4 + msgp.Uint64Size + 3 + (*z).SignedTxnWithAD.ApplyData.SenderRewards.Msgsize() + 3 + (*z).SignedTxnWithAD.ApplyData.ReceiverRewards.Msgsize() + 3 + (*z).SignedTxnWithAD.ApplyData.CloseRewards.Msgsize() + 3 + (*z).SignedTxnWithAD.ApplyData.EvalDelta.Msgsize() + 5 + (*z).SignedTxnWithAD.ApplyData.ConfigAsset.Msgsize() + 5 + (*z).SignedTxnWithAD.ApplyData.ApplicationID.Msgsize() + 4 + msgp.BoolSize + 4 + msgp.BoolSize
	return
}

// MsgIsZero returns whether this is a zero value
func (z *SignedTxnInBlock) MsgIsZero() bool {
	return ((*z).SignedTxnWithAD.SignedTxn.Sig.MsgIsZero()) && ((*z).SignedTxnWithAD.SignedTxn.Msig.MsgIsZero()) && ((*z).SignedTxnWithAD.SignedTxn.Lsig.MsgIsZero()) && ((*z).SignedTxnWithAD.SignedTxn.Txn.MsgIsZero()) && ((*z).SignedTxnWithAD.SignedTxn.AuthAddr.MsgIsZero()) && ((*z).SignedTxnWithAD.ApplyData.ClosingAmount.MsgIsZero()) && ((*z).SignedTxnWithAD.ApplyData.AssetClosingAmount == 0) && ((*z).SignedTxnWithAD.ApplyData.SenderRewards.MsgIsZero()) && ((*z).SignedTxnWithAD.ApplyData.ReceiverRewards.MsgIsZero()) && ((*z).SignedTxnWithAD.ApplyData.CloseRewards.MsgIsZero()) && ((*z).SignedTxnWithAD.ApplyData.EvalDelta.MsgIsZero()) && ((*z).SignedTxnWithAD.ApplyData.ConfigAsset.MsgIsZero()) && ((*z).SignedTxnWithAD.ApplyData.ApplicationID.MsgIsZero()) && ((*z).HasGenesisID == false) && ((*z).HasGenesisHash == false)
}

// MarshalMsg implements msgp.Marshaler
func (z *SignedTxnWithAD) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0001Len := uint32(13)
	var zb0001Mask uint16 /* 16 bits */
	if (*z).ApplyData.AssetClosingAmount == 0 {
		zb0001Len--
		zb0001Mask |= 0x8
	}
	if (*z).ApplyData.ApplicationID.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x10
	}
	if (*z).ApplyData.ClosingAmount.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x20
	}
	if (*z).ApplyData.ConfigAsset.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x40
	}
	if (*z).ApplyData.EvalDelta.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x80
	}
	if (*z).SignedTxn.Lsig.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x100
	}
	if (*z).SignedTxn.Msig.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x200
	}
	if (*z).ApplyData.CloseRewards.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x400
	}
	if (*z).ApplyData.ReceiverRewards.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x800
	}
	if (*z).ApplyData.SenderRewards.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x1000
	}
	if (*z).SignedTxn.AuthAddr.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x2000
	}
	if (*z).SignedTxn.Sig.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x4000
	}
	if (*z).SignedTxn.Txn.MsgIsZero() {
		zb0001Len--
		zb0001Mask |= 0x8000
	}
	// variable map header, size zb0001Len
	o = append(o, 0x80|uint8(zb0001Len))
	if zb0001Len != 0 {
		if (zb0001Mask & 0x8) == 0 { // if not empty
			// string "aca"
			o = append(o, 0xa3, 0x61, 0x63, 0x61)
			o = msgp.AppendUint64(o, (*z).ApplyData.AssetClosingAmount)
		}
		if (zb0001Mask & 0x10) == 0 { // if not empty
			// string "apid"
			o = append(o, 0xa4, 0x61, 0x70, 0x69, 0x64)
			o = (*z).ApplyData.ApplicationID.MarshalMsg(o)
		}
		if (zb0001Mask & 0x20) == 0 { // if not empty
			// string "ca"
			o = append(o, 0xa2, 0x63, 0x61)
			o = (*z).ApplyData.ClosingAmount.MarshalMsg(o)
		}
		if (zb0001Mask & 0x40) == 0 { // if not empty
			// string "caid"
			o = append(o, 0xa4, 0x63, 0x61, 0x69, 0x64)
			o = (*z).ApplyData.ConfigAsset.MarshalMsg(o)
		}
		if (zb0001Mask & 0x80) == 0 { // if not empty
			// string "dt"
			o = append(o, 0xa2, 0x64, 0x74)
			o = (*z).ApplyData.EvalDelta.MarshalMsg(o)
		}
		if (zb0001Mask & 0x100) == 0 { // if not empty
			// string "lsig"
			o = append(o, 0xa4, 0x6c, 0x73, 0x69, 0x67)
			o = (*z).SignedTxn.Lsig.MarshalMsg(o)
		}
		if (zb0001Mask & 0x200) == 0 { // if not empty
			// string "msig"
			o = append(o, 0xa4, 0x6d, 0x73, 0x69, 0x67)
			o = (*z).SignedTxn.Msig.MarshalMsg(o)
		}
		if (zb0001Mask & 0x400) == 0 { // if not empty
			// string "rc"
			o = append(o, 0xa2, 0x72, 0x63)
			o = (*z).ApplyData.CloseRewards.MarshalMsg(o)
		}
		if (zb0001Mask & 0x800) == 0 { // if not empty
			// string "rr"
			o = append(o, 0xa2, 0x72, 0x72)
			o = (*z).ApplyData.ReceiverRewards.MarshalMsg(o)
		}
		if (zb0001Mask & 0x1000) == 0 { // if not empty
			// string "rs"
			o = append(o, 0xa2, 0x72, 0x73)
			o = (*z).ApplyData.SenderRewards.MarshalMsg(o)
		}
		if (zb0001Mask & 0x2000) == 0 { // if not empty
			// string "sgnr"
			o = append(o, 0xa4, 0x73, 0x67, 0x6e, 0x72)
			o = (*z).SignedTxn.AuthAddr.MarshalMsg(o)
		}
		if (zb0001Mask & 0x4000) == 0 { // if not empty
			// string "sig"
			o = append(o, 0xa3, 0x73, 0x69, 0x67)
			o = (*z).SignedTxn.Sig.MarshalMsg(o)
		}
		if (zb0001Mask & 0x8000) == 0 { // if not empty
			// string "txn"
			o = append(o, 0xa3, 0x74, 0x78, 0x6e)
			o = (*z).SignedTxn.Txn.MarshalMsg(o)
		}
	}
	return
}

func (_ *SignedTxnWithAD) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*SignedTxnWithAD)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *SignedTxnWithAD) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0001 int
	var zb0002 bool
	zb0001, zb0002, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0001, zb0002, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxn.Sig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Sig")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxn.Msig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Msig")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxn.Lsig.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Lsig")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxn.Txn.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Txn")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).SignedTxn.AuthAddr.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AuthAddr")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ApplyData.ClosingAmount.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ClosingAmount")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			(*z).ApplyData.AssetClosingAmount, bts, err = msgp.ReadUint64Bytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetClosingAmount")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ApplyData.SenderRewards.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "SenderRewards")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ApplyData.ReceiverRewards.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ReceiverRewards")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ApplyData.CloseRewards.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "CloseRewards")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ApplyData.EvalDelta.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "EvalDelta")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ApplyData.ConfigAsset.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ConfigAsset")
				return
			}
		}
		if zb0001 > 0 {
			zb0001--
			bts, err = (*z).ApplyData.ApplicationID.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApplicationID")
				return
			}
		}
		if zb0001 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0001)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 {
			(*z) = SignedTxnWithAD{}
		}
		for zb0001 > 0 {
			zb0001--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "sig":
				bts, err = (*z).SignedTxn.Sig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Sig")
					return
				}
			case "msig":
				bts, err = (*z).SignedTxn.Msig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Msig")
					return
				}
			case "lsig":
				bts, err = (*z).SignedTxn.Lsig.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Lsig")
					return
				}
			case "txn":
				bts, err = (*z).SignedTxn.Txn.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Txn")
					return
				}
			case "sgnr":
				bts, err = (*z).SignedTxn.AuthAddr.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AuthAddr")
					return
				}
			case "ca":
				bts, err = (*z).ApplyData.ClosingAmount.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ClosingAmount")
					return
				}
			case "aca":
				(*z).ApplyData.AssetClosingAmount, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetClosingAmount")
					return
				}
			case "rs":
				bts, err = (*z).ApplyData.SenderRewards.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "SenderRewards")
					return
				}
			case "rr":
				bts, err = (*z).ApplyData.ReceiverRewards.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ReceiverRewards")
					return
				}
			case "rc":
				bts, err = (*z).ApplyData.CloseRewards.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "CloseRewards")
					return
				}
			case "dt":
				bts, err = (*z).ApplyData.EvalDelta.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "EvalDelta")
					return
				}
			case "caid":
				bts, err = (*z).ApplyData.ConfigAsset.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ConfigAsset")
					return
				}
			case "apid":
				bts, err = (*z).ApplyData.ApplicationID.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ApplicationID")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *SignedTxnWithAD) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*SignedTxnWithAD)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *SignedTxnWithAD) Msgsize() (s int) {
	s = 1 + 4 + (*z).SignedTxn.Sig.Msgsize() + 5 + (*z).SignedTxn.Msig.Msgsize() + 5 + (*z).SignedTxn.Lsig.Msgsize() + 4 + (*z).SignedTxn.Txn.Msgsize() + 5 + (*z).SignedTxn.AuthAddr.Msgsize() + 3 + (*z).ApplyData.ClosingAmount.Msgsize() + 4 + msgp.Uint64Size + 3 + (*z).ApplyData.SenderRewards.Msgsize() + 3 + (*z).ApplyData.ReceiverRewards.Msgsize() + 3 + (*z).ApplyData.CloseRewards.Msgsize() + 3 + (*z).ApplyData.EvalDelta.Msgsize() + 5 + (*z).ApplyData.ConfigAsset.Msgsize() + 5 + (*z).ApplyData.ApplicationID.Msgsize()
	return
}

// MsgIsZero returns whether this is a zero value
func (z *SignedTxnWithAD) MsgIsZero() bool {
	return ((*z).SignedTxn.Sig.MsgIsZero()) && ((*z).SignedTxn.Msig.MsgIsZero()) && ((*z).SignedTxn.Lsig.MsgIsZero()) && ((*z).SignedTxn.Txn.MsgIsZero()) && ((*z).SignedTxn.AuthAddr.MsgIsZero()) && ((*z).ApplyData.ClosingAmount.MsgIsZero()) && ((*z).ApplyData.AssetClosingAmount == 0) && ((*z).ApplyData.SenderRewards.MsgIsZero()) && ((*z).ApplyData.ReceiverRewards.MsgIsZero()) && ((*z).ApplyData.CloseRewards.MsgIsZero()) && ((*z).ApplyData.EvalDelta.MsgIsZero()) && ((*z).ApplyData.ConfigAsset.MsgIsZero()) && ((*z).ApplyData.ApplicationID.MsgIsZero())
}

// MarshalMsg implements msgp.Marshaler
func (z *Transaction) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0006Len := uint32(45)
	var zb0006Mask uint64 /* 54 bits */
	if (*z).AssetTransferTxnFields.AssetAmount == 0 {
		zb0006Len--
		zb0006Mask |= 0x200
	}
	if (*z).AssetTransferTxnFields.AssetCloseTo.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x400
	}
	if (*z).AssetFreezeTxnFields.AssetFrozen == false {
		zb0006Len--
		zb0006Mask |= 0x800
	}
	if (*z).PaymentTxnFields.Amount.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x1000
	}
	if len((*z).ApplicationCallTxnFields.ApplicationArgs) == 0 {
		zb0006Len--
		zb0006Mask |= 0x2000
	}
	if (*z).ApplicationCallTxnFields.OnCompletion == 0 {
		zb0006Len--
		zb0006Mask |= 0x4000
	}
	if len((*z).ApplicationCallTxnFields.ApprovalProgram) == 0 {
		zb0006Len--
		zb0006Mask |= 0x8000
	}
	if (*z).AssetConfigTxnFields.AssetParams.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x10000
	}
	if len((*z).ApplicationCallTxnFields.ForeignAssets) == 0 {
		zb0006Len--
		zb0006Mask |= 0x20000
	}
	if len((*z).ApplicationCallTxnFields.Accounts) == 0 {
		zb0006Len--
		zb0006Mask |= 0x40000
	}
	if (*z).ApplicationCallTxnFields.ExtraProgramPages == 0 {
		zb0006Len--
		zb0006Mask |= 0x80000
	}
	if len((*z).ApplicationCallTxnFields.ForeignApps) == 0 {
		zb0006Len--
		zb0006Mask |= 0x100000
	}
	if (*z).ApplicationCallTxnFields.GlobalStateSchema.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x200000
	}
	if (*z).ApplicationCallTxnFields.ApplicationID.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x400000
	}
	if (*z).ApplicationCallTxnFields.LocalStateSchema.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x800000
	}
	if len((*z).ApplicationCallTxnFields.ClearStateProgram) == 0 {
		zb0006Len--
		zb0006Mask |= 0x1000000
	}
	if (*z).AssetTransferTxnFields.AssetReceiver.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x2000000
	}
	if (*z).AssetTransferTxnFields.AssetSender.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x4000000
	}
	if (*z).AssetConfigTxnFields.ConfigAsset.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x8000000
	}
	if (*z).CompactCertTxnFields.Cert.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x10000000
	}
	if (*z).CompactCertTxnFields.CertRound.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x20000000
	}
	if (*z).CompactCertTxnFields.CertType.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x40000000
	}
	if (*z).PaymentTxnFields.CloseRemainderTo.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x80000000
	}
	if (*z).AssetFreezeTxnFields.FreezeAccount.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x100000000
	}
	if (*z).AssetFreezeTxnFields.FreezeAsset.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x200000000
	}
	if (*z).Header.Fee.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x400000000
	}
	if (*z).Header.FirstValid.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x800000000
	}
	if (*z).Header.GenesisID == "" {
		zb0006Len--
		zb0006Mask |= 0x1000000000
	}
	if (*z).Header.GenesisHash.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x2000000000
	}
	if (*z).Header.Group.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x4000000000
	}
	if (*z).Header.LastValid.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x8000000000
	}
	if (*z).Header.Lease == ([32]byte{}) {
		zb0006Len--
		zb0006Mask |= 0x10000000000
	}
	if (*z).KeyregTxnFields.Nonparticipation == false {
		zb0006Len--
		zb0006Mask |= 0x20000000000
	}
	if len((*z).Header.Note) == 0 {
		zb0006Len--
		zb0006Mask |= 0x40000000000
	}
	if (*z).PaymentTxnFields.Receiver.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x80000000000
	}
	if (*z).Header.RekeyTo.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x100000000000
	}
	if (*z).KeyregTxnFields.SelectionPK.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x200000000000
	}
	if (*z).Header.Sender.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x400000000000
	}
	if (*z).KeyregTxnFields.StateProofPK.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x800000000000
	}
	if (*z).Type.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x1000000000000
	}
	if (*z).KeyregTxnFields.VoteFirst.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x2000000000000
	}
	if (*z).KeyregTxnFields.VoteKeyDilution == 0 {
		zb0006Len--
		zb0006Mask |= 0x4000000000000
	}
	if (*z).KeyregTxnFields.VotePK.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x8000000000000
	}
	if (*z).KeyregTxnFields.VoteLast.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x10000000000000
	}
	if (*z).AssetTransferTxnFields.XferAsset.MsgIsZero() {
		zb0006Len--
		zb0006Mask |= 0x20000000000000
	}
	// variable map header, size zb0006Len
	o = msgp.AppendMapHeader(o, zb0006Len)
	if zb0006Len != 0 {
		if (zb0006Mask & 0x200) == 0 { // if not empty
			// string "aamt"
			o = append(o, 0xa4, 0x61, 0x61, 0x6d, 0x74)
			o = msgp.AppendUint64(o, (*z).AssetTransferTxnFields.AssetAmount)
		}
		if (zb0006Mask & 0x400) == 0 { // if not empty
			// string "aclose"
			o = append(o, 0xa6, 0x61, 0x63, 0x6c, 0x6f, 0x73, 0x65)
			o = (*z).AssetTransferTxnFields.AssetCloseTo.MarshalMsg(o)
		}
		if (zb0006Mask & 0x800) == 0 { // if not empty
			// string "afrz"
			o = append(o, 0xa4, 0x61, 0x66, 0x72, 0x7a)
			o = msgp.AppendBool(o, (*z).AssetFreezeTxnFields.AssetFrozen)
		}
		if (zb0006Mask & 0x1000) == 0 { // if not empty
			// string "amt"
			o = append(o, 0xa3, 0x61, 0x6d, 0x74)
			o = (*z).PaymentTxnFields.Amount.MarshalMsg(o)
		}
		if (zb0006Mask & 0x2000) == 0 { // if not empty
			// string "apaa"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x61)
			if (*z).ApplicationCallTxnFields.ApplicationArgs == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).ApplicationCallTxnFields.ApplicationArgs)))
			}
			for zb0002 := range (*z).ApplicationCallTxnFields.ApplicationArgs {
				o = msgp.AppendBytes(o, (*z).ApplicationCallTxnFields.ApplicationArgs[zb0002])
			}
		}
		if (zb0006Mask & 0x4000) == 0 { // if not empty
			// string "apan"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x6e)
			o = msgp.AppendUint64(o, uint64((*z).ApplicationCallTxnFields.OnCompletion))
		}
		if (zb0006Mask & 0x8000) == 0 { // if not empty
			// string "apap"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x70)
			o = msgp.AppendBytes(o, (*z).ApplicationCallTxnFields.ApprovalProgram)
		}
		if (zb0006Mask & 0x10000) == 0 { // if not empty
			// string "apar"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x72)
			o = (*z).AssetConfigTxnFields.AssetParams.MarshalMsg(o)
		}
		if (zb0006Mask & 0x20000) == 0 { // if not empty
			// string "apas"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x73)
			if (*z).ApplicationCallTxnFields.ForeignAssets == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).ApplicationCallTxnFields.ForeignAssets)))
			}
			for zb0005 := range (*z).ApplicationCallTxnFields.ForeignAssets {
				o = (*z).ApplicationCallTxnFields.ForeignAssets[zb0005].MarshalMsg(o)
			}
		}
		if (zb0006Mask & 0x40000) == 0 { // if not empty
			// string "apat"
			o = append(o, 0xa4, 0x61, 0x70, 0x61, 0x74)
			if (*z).ApplicationCallTxnFields.Accounts == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).ApplicationCallTxnFields.Accounts)))
			}
			for zb0003 := range (*z).ApplicationCallTxnFields.Accounts {
				o = (*z).ApplicationCallTxnFields.Accounts[zb0003].MarshalMsg(o)
			}
		}
		if (zb0006Mask & 0x80000) == 0 { // if not empty
			// string "apep"
			o = append(o, 0xa4, 0x61, 0x70, 0x65, 0x70)
			o = msgp.AppendUint32(o, (*z).ApplicationCallTxnFields.ExtraProgramPages)
		}
		if (zb0006Mask & 0x100000) == 0 { // if not empty
			// string "apfa"
			o = append(o, 0xa4, 0x61, 0x70, 0x66, 0x61)
			if (*z).ApplicationCallTxnFields.ForeignApps == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).ApplicationCallTxnFields.ForeignApps)))
			}
			for zb0004 := range (*z).ApplicationCallTxnFields.ForeignApps {
				o = (*z).ApplicationCallTxnFields.ForeignApps[zb0004].MarshalMsg(o)
			}
		}
		if (zb0006Mask & 0x200000) == 0 { // if not empty
			// string "apgs"
			o = append(o, 0xa4, 0x61, 0x70, 0x67, 0x73)
			o = (*z).ApplicationCallTxnFields.GlobalStateSchema.MarshalMsg(o)
		}
		if (zb0006Mask & 0x400000) == 0 { // if not empty
			// string "apid"
			o = append(o, 0xa4, 0x61, 0x70, 0x69, 0x64)
			o = (*z).ApplicationCallTxnFields.ApplicationID.MarshalMsg(o)
		}
		if (zb0006Mask & 0x800000) == 0 { // if not empty
			// string "apls"
			o = append(o, 0xa4, 0x61, 0x70, 0x6c, 0x73)
			o = (*z).ApplicationCallTxnFields.LocalStateSchema.MarshalMsg(o)
		}
		if (zb0006Mask & 0x1000000) == 0 { // if not empty
			// string "apsu"
			o = append(o, 0xa4, 0x61, 0x70, 0x73, 0x75)
			o = msgp.AppendBytes(o, (*z).ApplicationCallTxnFields.ClearStateProgram)
		}
		if (zb0006Mask & 0x2000000) == 0 { // if not empty
			// string "arcv"
			o = append(o, 0xa4, 0x61, 0x72, 0x63, 0x76)
			o = (*z).AssetTransferTxnFields.AssetReceiver.MarshalMsg(o)
		}
		if (zb0006Mask & 0x4000000) == 0 { // if not empty
			// string "asnd"
			o = append(o, 0xa4, 0x61, 0x73, 0x6e, 0x64)
			o = (*z).AssetTransferTxnFields.AssetSender.MarshalMsg(o)
		}
		if (zb0006Mask & 0x8000000) == 0 { // if not empty
			// string "caid"
			o = append(o, 0xa4, 0x63, 0x61, 0x69, 0x64)
			o = (*z).AssetConfigTxnFields.ConfigAsset.MarshalMsg(o)
		}
		if (zb0006Mask & 0x10000000) == 0 { // if not empty
			// string "cert"
			o = append(o, 0xa4, 0x63, 0x65, 0x72, 0x74)
			o = (*z).CompactCertTxnFields.Cert.MarshalMsg(o)
		}
		if (zb0006Mask & 0x20000000) == 0 { // if not empty
			// string "certrnd"
			o = append(o, 0xa7, 0x63, 0x65, 0x72, 0x74, 0x72, 0x6e, 0x64)
			o = (*z).CompactCertTxnFields.CertRound.MarshalMsg(o)
		}
		if (zb0006Mask & 0x40000000) == 0 { // if not empty
			// string "certtype"
			o = append(o, 0xa8, 0x63, 0x65, 0x72, 0x74, 0x74, 0x79, 0x70, 0x65)
			o = (*z).CompactCertTxnFields.CertType.MarshalMsg(o)
		}
		if (zb0006Mask & 0x80000000) == 0 { // if not empty
			// string "close"
			o = append(o, 0xa5, 0x63, 0x6c, 0x6f, 0x73, 0x65)
			o = (*z).PaymentTxnFields.CloseRemainderTo.MarshalMsg(o)
		}
		if (zb0006Mask & 0x100000000) == 0 { // if not empty
			// string "fadd"
			o = append(o, 0xa4, 0x66, 0x61, 0x64, 0x64)
			o = (*z).AssetFreezeTxnFields.FreezeAccount.MarshalMsg(o)
		}
		if (zb0006Mask & 0x200000000) == 0 { // if not empty
			// string "faid"
			o = append(o, 0xa4, 0x66, 0x61, 0x69, 0x64)
			o = (*z).AssetFreezeTxnFields.FreezeAsset.MarshalMsg(o)
		}
		if (zb0006Mask & 0x400000000) == 0 { // if not empty
			// string "fee"
			o = append(o, 0xa3, 0x66, 0x65, 0x65)
			o = (*z).Header.Fee.MarshalMsg(o)
		}
		if (zb0006Mask & 0x800000000) == 0 { // if not empty
			// string "fv"
			o = append(o, 0xa2, 0x66, 0x76)
			o = (*z).Header.FirstValid.MarshalMsg(o)
		}
		if (zb0006Mask & 0x1000000000) == 0 { // if not empty
			// string "gen"
			o = append(o, 0xa3, 0x67, 0x65, 0x6e)
			o = msgp.AppendString(o, (*z).Header.GenesisID)
		}
		if (zb0006Mask & 0x2000000000) == 0 { // if not empty
			// string "gh"
			o = append(o, 0xa2, 0x67, 0x68)
			o = (*z).Header.GenesisHash.MarshalMsg(o)
		}
		if (zb0006Mask & 0x4000000000) == 0 { // if not empty
			// string "grp"
			o = append(o, 0xa3, 0x67, 0x72, 0x70)
			o = (*z).Header.Group.MarshalMsg(o)
		}
		if (zb0006Mask & 0x8000000000) == 0 { // if not empty
			// string "lv"
			o = append(o, 0xa2, 0x6c, 0x76)
			o = (*z).Header.LastValid.MarshalMsg(o)
		}
		if (zb0006Mask & 0x10000000000) == 0 { // if not empty
			// string "lx"
			o = append(o, 0xa2, 0x6c, 0x78)
			o = msgp.AppendBytes(o, ((*z).Header.Lease)[:])
		}
		if (zb0006Mask & 0x20000000000) == 0 { // if not empty
			// string "nonpart"
			o = append(o, 0xa7, 0x6e, 0x6f, 0x6e, 0x70, 0x61, 0x72, 0x74)
			o = msgp.AppendBool(o, (*z).KeyregTxnFields.Nonparticipation)
		}
		if (zb0006Mask & 0x40000000000) == 0 { // if not empty
			// string "note"
			o = append(o, 0xa4, 0x6e, 0x6f, 0x74, 0x65)
			o = msgp.AppendBytes(o, (*z).Header.Note)
		}
		if (zb0006Mask & 0x80000000000) == 0 { // if not empty
			// string "rcv"
			o = append(o, 0xa3, 0x72, 0x63, 0x76)
			o = (*z).PaymentTxnFields.Receiver.MarshalMsg(o)
		}
		if (zb0006Mask & 0x100000000000) == 0 { // if not empty
			// string "rekey"
			o = append(o, 0xa5, 0x72, 0x65, 0x6b, 0x65, 0x79)
			o = (*z).Header.RekeyTo.MarshalMsg(o)
		}
		if (zb0006Mask & 0x200000000000) == 0 { // if not empty
			// string "selkey"
			o = append(o, 0xa6, 0x73, 0x65, 0x6c, 0x6b, 0x65, 0x79)
			o = (*z).KeyregTxnFields.SelectionPK.MarshalMsg(o)
		}
		if (zb0006Mask & 0x400000000000) == 0 { // if not empty
			// string "snd"
			o = append(o, 0xa3, 0x73, 0x6e, 0x64)
			o = (*z).Header.Sender.MarshalMsg(o)
		}
		if (zb0006Mask & 0x800000000000) == 0 { // if not empty
			// string "sprfkey"
			o = append(o, 0xa7, 0x73, 0x70, 0x72, 0x66, 0x6b, 0x65, 0x79)
			o = (*z).KeyregTxnFields.StateProofPK.MarshalMsg(o)
		}
		if (zb0006Mask & 0x1000000000000) == 0 { // if not empty
			// string "type"
			o = append(o, 0xa4, 0x74, 0x79, 0x70, 0x65)
			o = (*z).Type.MarshalMsg(o)
		}
		if (zb0006Mask & 0x2000000000000) == 0 { // if not empty
			// string "votefst"
			o = append(o, 0xa7, 0x76, 0x6f, 0x74, 0x65, 0x66, 0x73, 0x74)
			o = (*z).KeyregTxnFields.VoteFirst.MarshalMsg(o)
		}
		if (zb0006Mask & 0x4000000000000) == 0 { // if not empty
			// string "votekd"
			o = append(o, 0xa6, 0x76, 0x6f, 0x74, 0x65, 0x6b, 0x64)
			o = msgp.AppendUint64(o, (*z).KeyregTxnFields.VoteKeyDilution)
		}
		if (zb0006Mask & 0x8000000000000) == 0 { // if not empty
			// string "votekey"
			o = append(o, 0xa7, 0x76, 0x6f, 0x74, 0x65, 0x6b, 0x65, 0x79)
			o = (*z).KeyregTxnFields.VotePK.MarshalMsg(o)
		}
		if (zb0006Mask & 0x10000000000000) == 0 { // if not empty
			// string "votelst"
			o = append(o, 0xa7, 0x76, 0x6f, 0x74, 0x65, 0x6c, 0x73, 0x74)
			o = (*z).KeyregTxnFields.VoteLast.MarshalMsg(o)
		}
		if (zb0006Mask & 0x20000000000000) == 0 { // if not empty
			// string "xaid"
			o = append(o, 0xa4, 0x78, 0x61, 0x69, 0x64)
			o = (*z).AssetTransferTxnFields.XferAsset.MarshalMsg(o)
		}
	}
	return
}

func (_ *Transaction) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*Transaction)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *Transaction) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0006 int
	var zb0007 bool
	zb0006, zb0007, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0006, zb0007, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).Type.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Type")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).Header.Sender.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Sender")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).Header.Fee.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Fee")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).Header.FirstValid.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "FirstValid")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).Header.LastValid.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "LastValid")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			var zb0008 int
			zb0008, err = msgp.ReadBytesBytesHeader(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Note")
				return
			}
			if zb0008 > config.MaxTxnNoteBytes {
				err = msgp.ErrOverflow(uint64(zb0008), uint64(config.MaxTxnNoteBytes))
				return
			}
			(*z).Header.Note, bts, err = msgp.ReadBytesBytes(bts, (*z).Header.Note)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Note")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			(*z).Header.GenesisID, bts, err = msgp.ReadStringBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "GenesisID")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).Header.GenesisHash.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "GenesisHash")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).Header.Group.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Group")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = msgp.ReadExactBytes(bts, ((*z).Header.Lease)[:])
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Lease")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).Header.RekeyTo.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "RekeyTo")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).KeyregTxnFields.VotePK.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "VotePK")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).KeyregTxnFields.SelectionPK.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "SelectionPK")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).KeyregTxnFields.StateProofPK.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "StateProofPK")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).KeyregTxnFields.VoteFirst.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "VoteFirst")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).KeyregTxnFields.VoteLast.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "VoteLast")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			(*z).KeyregTxnFields.VoteKeyDilution, bts, err = msgp.ReadUint64Bytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "VoteKeyDilution")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			(*z).KeyregTxnFields.Nonparticipation, bts, err = msgp.ReadBoolBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Nonparticipation")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).PaymentTxnFields.Receiver.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Receiver")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).PaymentTxnFields.Amount.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Amount")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).PaymentTxnFields.CloseRemainderTo.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "CloseRemainderTo")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).AssetConfigTxnFields.ConfigAsset.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ConfigAsset")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).AssetConfigTxnFields.AssetParams.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetParams")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).AssetTransferTxnFields.XferAsset.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "XferAsset")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			(*z).AssetTransferTxnFields.AssetAmount, bts, err = msgp.ReadUint64Bytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetAmount")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).AssetTransferTxnFields.AssetSender.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetSender")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).AssetTransferTxnFields.AssetReceiver.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetReceiver")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).AssetTransferTxnFields.AssetCloseTo.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetCloseTo")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).AssetFreezeTxnFields.FreezeAccount.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "FreezeAccount")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).AssetFreezeTxnFields.FreezeAsset.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "FreezeAsset")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			(*z).AssetFreezeTxnFields.AssetFrozen, bts, err = msgp.ReadBoolBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "AssetFrozen")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).ApplicationCallTxnFields.ApplicationID.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApplicationID")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			{
				var zb0009 uint64
				zb0009, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "OnCompletion")
					return
				}
				(*z).ApplicationCallTxnFields.OnCompletion = OnCompletion(zb0009)
			}
		}
		if zb0006 > 0 {
			zb0006--
			var zb0010 int
			var zb0011 bool
			zb0010, zb0011, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApplicationArgs")
				return
			}
			if zb0010 > encodedMaxApplicationArgs {
				err = msgp.ErrOverflow(uint64(zb0010), uint64(encodedMaxApplicationArgs))
				err = msgp.WrapError(err, "struct-from-array", "ApplicationArgs")
				return
			}
			if zb0011 {
				(*z).ApplicationCallTxnFields.ApplicationArgs = nil
			} else if (*z).ApplicationCallTxnFields.ApplicationArgs != nil && cap((*z).ApplicationCallTxnFields.ApplicationArgs) >= zb0010 {
				(*z).ApplicationCallTxnFields.ApplicationArgs = ((*z).ApplicationCallTxnFields.ApplicationArgs)[:zb0010]
			} else {
				(*z).ApplicationCallTxnFields.ApplicationArgs = make([][]byte, zb0010)
			}
			for zb0002 := range (*z).ApplicationCallTxnFields.ApplicationArgs {
				(*z).ApplicationCallTxnFields.ApplicationArgs[zb0002], bts, err = msgp.ReadBytesBytes(bts, (*z).ApplicationCallTxnFields.ApplicationArgs[zb0002])
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "ApplicationArgs", zb0002)
					return
				}
			}
		}
		if zb0006 > 0 {
			zb0006--
			var zb0012 int
			var zb0013 bool
			zb0012, zb0013, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Accounts")
				return
			}
			if zb0012 > encodedMaxAccounts {
				err = msgp.ErrOverflow(uint64(zb0012), uint64(encodedMaxAccounts))
				err = msgp.WrapError(err, "struct-from-array", "Accounts")
				return
			}
			if zb0013 {
				(*z).ApplicationCallTxnFields.Accounts = nil
			} else if (*z).ApplicationCallTxnFields.Accounts != nil && cap((*z).ApplicationCallTxnFields.Accounts) >= zb0012 {
				(*z).ApplicationCallTxnFields.Accounts = ((*z).ApplicationCallTxnFields.Accounts)[:zb0012]
			} else {
				(*z).ApplicationCallTxnFields.Accounts = make([]basics.Address, zb0012)
			}
			for zb0003 := range (*z).ApplicationCallTxnFields.Accounts {
				bts, err = (*z).ApplicationCallTxnFields.Accounts[zb0003].UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "Accounts", zb0003)
					return
				}
			}
		}
		if zb0006 > 0 {
			zb0006--
			var zb0014 int
			var zb0015 bool
			zb0014, zb0015, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ForeignApps")
				return
			}
			if zb0014 > encodedMaxForeignApps {
				err = msgp.ErrOverflow(uint64(zb0014), uint64(encodedMaxForeignApps))
				err = msgp.WrapError(err, "struct-from-array", "ForeignApps")
				return
			}
			if zb0015 {
				(*z).ApplicationCallTxnFields.ForeignApps = nil
			} else if (*z).ApplicationCallTxnFields.ForeignApps != nil && cap((*z).ApplicationCallTxnFields.ForeignApps) >= zb0014 {
				(*z).ApplicationCallTxnFields.ForeignApps = ((*z).ApplicationCallTxnFields.ForeignApps)[:zb0014]
			} else {
				(*z).ApplicationCallTxnFields.ForeignApps = make([]basics.AppIndex, zb0014)
			}
			for zb0004 := range (*z).ApplicationCallTxnFields.ForeignApps {
				bts, err = (*z).ApplicationCallTxnFields.ForeignApps[zb0004].UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "ForeignApps", zb0004)
					return
				}
			}
		}
		if zb0006 > 0 {
			zb0006--
			var zb0016 int
			var zb0017 bool
			zb0016, zb0017, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ForeignAssets")
				return
			}
			if zb0016 > encodedMaxForeignAssets {
				err = msgp.ErrOverflow(uint64(zb0016), uint64(encodedMaxForeignAssets))
				err = msgp.WrapError(err, "struct-from-array", "ForeignAssets")
				return
			}
			if zb0017 {
				(*z).ApplicationCallTxnFields.ForeignAssets = nil
			} else if (*z).ApplicationCallTxnFields.ForeignAssets != nil && cap((*z).ApplicationCallTxnFields.ForeignAssets) >= zb0016 {
				(*z).ApplicationCallTxnFields.ForeignAssets = ((*z).ApplicationCallTxnFields.ForeignAssets)[:zb0016]
			} else {
				(*z).ApplicationCallTxnFields.ForeignAssets = make([]basics.AssetIndex, zb0016)
			}
			for zb0005 := range (*z).ApplicationCallTxnFields.ForeignAssets {
				bts, err = (*z).ApplicationCallTxnFields.ForeignAssets[zb0005].UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "ForeignAssets", zb0005)
					return
				}
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).ApplicationCallTxnFields.LocalStateSchema.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "LocalStateSchema")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).ApplicationCallTxnFields.GlobalStateSchema.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "GlobalStateSchema")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			var zb0018 int
			zb0018, err = msgp.ReadBytesBytesHeader(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApprovalProgram")
				return
			}
			if zb0018 > config.MaxAvailableAppProgramLen {
				err = msgp.ErrOverflow(uint64(zb0018), uint64(config.MaxAvailableAppProgramLen))
				return
			}
			(*z).ApplicationCallTxnFields.ApprovalProgram, bts, err = msgp.ReadBytesBytes(bts, (*z).ApplicationCallTxnFields.ApprovalProgram)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ApprovalProgram")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			var zb0019 int
			zb0019, err = msgp.ReadBytesBytesHeader(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ClearStateProgram")
				return
			}
			if zb0019 > config.MaxAvailableAppProgramLen {
				err = msgp.ErrOverflow(uint64(zb0019), uint64(config.MaxAvailableAppProgramLen))
				return
			}
			(*z).ApplicationCallTxnFields.ClearStateProgram, bts, err = msgp.ReadBytesBytes(bts, (*z).ApplicationCallTxnFields.ClearStateProgram)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ClearStateProgram")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			(*z).ApplicationCallTxnFields.ExtraProgramPages, bts, err = msgp.ReadUint32Bytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "ExtraProgramPages")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).CompactCertTxnFields.CertRound.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "CertRound")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).CompactCertTxnFields.CertType.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "CertType")
				return
			}
		}
		if zb0006 > 0 {
			zb0006--
			bts, err = (*z).CompactCertTxnFields.Cert.UnmarshalMsg(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "Cert")
				return
			}
		}
		if zb0006 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0006)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0007 {
			(*z) = Transaction{}
		}
		for zb0006 > 0 {
			zb0006--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "type":
				bts, err = (*z).Type.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Type")
					return
				}
			case "snd":
				bts, err = (*z).Header.Sender.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Sender")
					return
				}
			case "fee":
				bts, err = (*z).Header.Fee.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Fee")
					return
				}
			case "fv":
				bts, err = (*z).Header.FirstValid.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "FirstValid")
					return
				}
			case "lv":
				bts, err = (*z).Header.LastValid.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "LastValid")
					return
				}
			case "note":
				var zb0020 int
				zb0020, err = msgp.ReadBytesBytesHeader(bts)
				if err != nil {
					err = msgp.WrapError(err, "Note")
					return
				}
				if zb0020 > config.MaxTxnNoteBytes {
					err = msgp.ErrOverflow(uint64(zb0020), uint64(config.MaxTxnNoteBytes))
					return
				}
				(*z).Header.Note, bts, err = msgp.ReadBytesBytes(bts, (*z).Header.Note)
				if err != nil {
					err = msgp.WrapError(err, "Note")
					return
				}
			case "gen":
				(*z).Header.GenesisID, bts, err = msgp.ReadStringBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "GenesisID")
					return
				}
			case "gh":
				bts, err = (*z).Header.GenesisHash.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "GenesisHash")
					return
				}
			case "grp":
				bts, err = (*z).Header.Group.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Group")
					return
				}
			case "lx":
				bts, err = msgp.ReadExactBytes(bts, ((*z).Header.Lease)[:])
				if err != nil {
					err = msgp.WrapError(err, "Lease")
					return
				}
			case "rekey":
				bts, err = (*z).Header.RekeyTo.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "RekeyTo")
					return
				}
			case "votekey":
				bts, err = (*z).KeyregTxnFields.VotePK.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "VotePK")
					return
				}
			case "selkey":
				bts, err = (*z).KeyregTxnFields.SelectionPK.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "SelectionPK")
					return
				}
			case "sprfkey":
				bts, err = (*z).KeyregTxnFields.StateProofPK.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "StateProofPK")
					return
				}
			case "votefst":
				bts, err = (*z).KeyregTxnFields.VoteFirst.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "VoteFirst")
					return
				}
			case "votelst":
				bts, err = (*z).KeyregTxnFields.VoteLast.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "VoteLast")
					return
				}
			case "votekd":
				(*z).KeyregTxnFields.VoteKeyDilution, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "VoteKeyDilution")
					return
				}
			case "nonpart":
				(*z).KeyregTxnFields.Nonparticipation, bts, err = msgp.ReadBoolBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "Nonparticipation")
					return
				}
			case "rcv":
				bts, err = (*z).PaymentTxnFields.Receiver.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Receiver")
					return
				}
			case "amt":
				bts, err = (*z).PaymentTxnFields.Amount.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Amount")
					return
				}
			case "close":
				bts, err = (*z).PaymentTxnFields.CloseRemainderTo.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "CloseRemainderTo")
					return
				}
			case "caid":
				bts, err = (*z).AssetConfigTxnFields.ConfigAsset.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ConfigAsset")
					return
				}
			case "apar":
				bts, err = (*z).AssetConfigTxnFields.AssetParams.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetParams")
					return
				}
			case "xaid":
				bts, err = (*z).AssetTransferTxnFields.XferAsset.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "XferAsset")
					return
				}
			case "aamt":
				(*z).AssetTransferTxnFields.AssetAmount, bts, err = msgp.ReadUint64Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetAmount")
					return
				}
			case "asnd":
				bts, err = (*z).AssetTransferTxnFields.AssetSender.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetSender")
					return
				}
			case "arcv":
				bts, err = (*z).AssetTransferTxnFields.AssetReceiver.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetReceiver")
					return
				}
			case "aclose":
				bts, err = (*z).AssetTransferTxnFields.AssetCloseTo.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetCloseTo")
					return
				}
			case "fadd":
				bts, err = (*z).AssetFreezeTxnFields.FreezeAccount.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "FreezeAccount")
					return
				}
			case "faid":
				bts, err = (*z).AssetFreezeTxnFields.FreezeAsset.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "FreezeAsset")
					return
				}
			case "afrz":
				(*z).AssetFreezeTxnFields.AssetFrozen, bts, err = msgp.ReadBoolBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "AssetFrozen")
					return
				}
			case "apid":
				bts, err = (*z).ApplicationCallTxnFields.ApplicationID.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "ApplicationID")
					return
				}
			case "apan":
				{
					var zb0021 uint64
					zb0021, bts, err = msgp.ReadUint64Bytes(bts)
					if err != nil {
						err = msgp.WrapError(err, "OnCompletion")
						return
					}
					(*z).ApplicationCallTxnFields.OnCompletion = OnCompletion(zb0021)
				}
			case "apaa":
				var zb0022 int
				var zb0023 bool
				zb0022, zb0023, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "ApplicationArgs")
					return
				}
				if zb0022 > encodedMaxApplicationArgs {
					err = msgp.ErrOverflow(uint64(zb0022), uint64(encodedMaxApplicationArgs))
					err = msgp.WrapError(err, "ApplicationArgs")
					return
				}
				if zb0023 {
					(*z).ApplicationCallTxnFields.ApplicationArgs = nil
				} else if (*z).ApplicationCallTxnFields.ApplicationArgs != nil && cap((*z).ApplicationCallTxnFields.ApplicationArgs) >= zb0022 {
					(*z).ApplicationCallTxnFields.ApplicationArgs = ((*z).ApplicationCallTxnFields.ApplicationArgs)[:zb0022]
				} else {
					(*z).ApplicationCallTxnFields.ApplicationArgs = make([][]byte, zb0022)
				}
				for zb0002 := range (*z).ApplicationCallTxnFields.ApplicationArgs {
					(*z).ApplicationCallTxnFields.ApplicationArgs[zb0002], bts, err = msgp.ReadBytesBytes(bts, (*z).ApplicationCallTxnFields.ApplicationArgs[zb0002])
					if err != nil {
						err = msgp.WrapError(err, "ApplicationArgs", zb0002)
						return
					}
				}
			case "apat":
				var zb0024 int
				var zb0025 bool
				zb0024, zb0025, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "Accounts")
					return
				}
				if zb0024 > encodedMaxAccounts {
					err = msgp.ErrOverflow(uint64(zb0024), uint64(encodedMaxAccounts))
					err = msgp.WrapError(err, "Accounts")
					return
				}
				if zb0025 {
					(*z).ApplicationCallTxnFields.Accounts = nil
				} else if (*z).ApplicationCallTxnFields.Accounts != nil && cap((*z).ApplicationCallTxnFields.Accounts) >= zb0024 {
					(*z).ApplicationCallTxnFields.Accounts = ((*z).ApplicationCallTxnFields.Accounts)[:zb0024]
				} else {
					(*z).ApplicationCallTxnFields.Accounts = make([]basics.Address, zb0024)
				}
				for zb0003 := range (*z).ApplicationCallTxnFields.Accounts {
					bts, err = (*z).ApplicationCallTxnFields.Accounts[zb0003].UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "Accounts", zb0003)
						return
					}
				}
			case "apfa":
				var zb0026 int
				var zb0027 bool
				zb0026, zb0027, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "ForeignApps")
					return
				}
				if zb0026 > encodedMaxForeignApps {
					err = msgp.ErrOverflow(uint64(zb0026), uint64(encodedMaxForeignApps))
					err = msgp.WrapError(err, "ForeignApps")
					return
				}
				if zb0027 {
					(*z).ApplicationCallTxnFields.ForeignApps = nil
				} else if (*z).ApplicationCallTxnFields.ForeignApps != nil && cap((*z).ApplicationCallTxnFields.ForeignApps) >= zb0026 {
					(*z).ApplicationCallTxnFields.ForeignApps = ((*z).ApplicationCallTxnFields.ForeignApps)[:zb0026]
				} else {
					(*z).ApplicationCallTxnFields.ForeignApps = make([]basics.AppIndex, zb0026)
				}
				for zb0004 := range (*z).ApplicationCallTxnFields.ForeignApps {
					bts, err = (*z).ApplicationCallTxnFields.ForeignApps[zb0004].UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "ForeignApps", zb0004)
						return
					}
				}
			case "apas":
				var zb0028 int
				var zb0029 bool
				zb0028, zb0029, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "ForeignAssets")
					return
				}
				if zb0028 > encodedMaxForeignAssets {
					err = msgp.ErrOverflow(uint64(zb0028), uint64(encodedMaxForeignAssets))
					err = msgp.WrapError(err, "ForeignAssets")
					return
				}
				if zb0029 {
					(*z).ApplicationCallTxnFields.ForeignAssets = nil
				} else if (*z).ApplicationCallTxnFields.ForeignAssets != nil && cap((*z).ApplicationCallTxnFields.ForeignAssets) >= zb0028 {
					(*z).ApplicationCallTxnFields.ForeignAssets = ((*z).ApplicationCallTxnFields.ForeignAssets)[:zb0028]
				} else {
					(*z).ApplicationCallTxnFields.ForeignAssets = make([]basics.AssetIndex, zb0028)
				}
				for zb0005 := range (*z).ApplicationCallTxnFields.ForeignAssets {
					bts, err = (*z).ApplicationCallTxnFields.ForeignAssets[zb0005].UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "ForeignAssets", zb0005)
						return
					}
				}
			case "apls":
				bts, err = (*z).ApplicationCallTxnFields.LocalStateSchema.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "LocalStateSchema")
					return
				}
			case "apgs":
				bts, err = (*z).ApplicationCallTxnFields.GlobalStateSchema.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "GlobalStateSchema")
					return
				}
			case "apap":
				var zb0030 int
				zb0030, err = msgp.ReadBytesBytesHeader(bts)
				if err != nil {
					err = msgp.WrapError(err, "ApprovalProgram")
					return
				}
				if zb0030 > config.MaxAvailableAppProgramLen {
					err = msgp.ErrOverflow(uint64(zb0030), uint64(config.MaxAvailableAppProgramLen))
					return
				}
				(*z).ApplicationCallTxnFields.ApprovalProgram, bts, err = msgp.ReadBytesBytes(bts, (*z).ApplicationCallTxnFields.ApprovalProgram)
				if err != nil {
					err = msgp.WrapError(err, "ApprovalProgram")
					return
				}
			case "apsu":
				var zb0031 int
				zb0031, err = msgp.ReadBytesBytesHeader(bts)
				if err != nil {
					err = msgp.WrapError(err, "ClearStateProgram")
					return
				}
				if zb0031 > config.MaxAvailableAppProgramLen {
					err = msgp.ErrOverflow(uint64(zb0031), uint64(config.MaxAvailableAppProgramLen))
					return
				}
				(*z).ApplicationCallTxnFields.ClearStateProgram, bts, err = msgp.ReadBytesBytes(bts, (*z).ApplicationCallTxnFields.ClearStateProgram)
				if err != nil {
					err = msgp.WrapError(err, "ClearStateProgram")
					return
				}
			case "apep":
				(*z).ApplicationCallTxnFields.ExtraProgramPages, bts, err = msgp.ReadUint32Bytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "ExtraProgramPages")
					return
				}
			case "certrnd":
				bts, err = (*z).CompactCertTxnFields.CertRound.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "CertRound")
					return
				}
			case "certtype":
				bts, err = (*z).CompactCertTxnFields.CertType.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "CertType")
					return
				}
			case "cert":
				bts, err = (*z).CompactCertTxnFields.Cert.UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "Cert")
					return
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *Transaction) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*Transaction)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *Transaction) Msgsize() (s int) {
	s = 3 + 5 + (*z).Type.Msgsize() + 4 + (*z).Header.Sender.Msgsize() + 4 + (*z).Header.Fee.Msgsize() + 3 + (*z).Header.FirstValid.Msgsize() + 3 + (*z).Header.LastValid.Msgsize() + 5 + msgp.BytesPrefixSize + len((*z).Header.Note) + 4 + msgp.StringPrefixSize + len((*z).Header.GenesisID) + 3 + (*z).Header.GenesisHash.Msgsize() + 4 + (*z).Header.Group.Msgsize() + 3 + msgp.ArrayHeaderSize + (32 * (msgp.ByteSize)) + 6 + (*z).Header.RekeyTo.Msgsize() + 8 + (*z).KeyregTxnFields.VotePK.Msgsize() + 7 + (*z).KeyregTxnFields.SelectionPK.Msgsize() + 8 + (*z).KeyregTxnFields.StateProofPK.Msgsize() + 8 + (*z).KeyregTxnFields.VoteFirst.Msgsize() + 8 + (*z).KeyregTxnFields.VoteLast.Msgsize() + 7 + msgp.Uint64Size + 8 + msgp.BoolSize + 4 + (*z).PaymentTxnFields.Receiver.Msgsize() + 4 + (*z).PaymentTxnFields.Amount.Msgsize() + 6 + (*z).PaymentTxnFields.CloseRemainderTo.Msgsize() + 5 + (*z).AssetConfigTxnFields.ConfigAsset.Msgsize() + 5 + (*z).AssetConfigTxnFields.AssetParams.Msgsize() + 5 + (*z).AssetTransferTxnFields.XferAsset.Msgsize() + 5 + msgp.Uint64Size + 5 + (*z).AssetTransferTxnFields.AssetSender.Msgsize() + 5 + (*z).AssetTransferTxnFields.AssetReceiver.Msgsize() + 7 + (*z).AssetTransferTxnFields.AssetCloseTo.Msgsize() + 5 + (*z).AssetFreezeTxnFields.FreezeAccount.Msgsize() + 5 + (*z).AssetFreezeTxnFields.FreezeAsset.Msgsize() + 5 + msgp.BoolSize + 5 + (*z).ApplicationCallTxnFields.ApplicationID.Msgsize() + 5 + msgp.Uint64Size + 5 + msgp.ArrayHeaderSize
	for zb0002 := range (*z).ApplicationCallTxnFields.ApplicationArgs {
		s += msgp.BytesPrefixSize + len((*z).ApplicationCallTxnFields.ApplicationArgs[zb0002])
	}
	s += 5 + msgp.ArrayHeaderSize
	for zb0003 := range (*z).ApplicationCallTxnFields.Accounts {
		s += (*z).ApplicationCallTxnFields.Accounts[zb0003].Msgsize()
	}
	s += 5 + msgp.ArrayHeaderSize
	for zb0004 := range (*z).ApplicationCallTxnFields.ForeignApps {
		s += (*z).ApplicationCallTxnFields.ForeignApps[zb0004].Msgsize()
	}
	s += 5 + msgp.ArrayHeaderSize
	for zb0005 := range (*z).ApplicationCallTxnFields.ForeignAssets {
		s += (*z).ApplicationCallTxnFields.ForeignAssets[zb0005].Msgsize()
	}
	s += 5 + (*z).ApplicationCallTxnFields.LocalStateSchema.Msgsize() + 5 + (*z).ApplicationCallTxnFields.GlobalStateSchema.Msgsize() + 5 + msgp.BytesPrefixSize + len((*z).ApplicationCallTxnFields.ApprovalProgram) + 5 + msgp.BytesPrefixSize + len((*z).ApplicationCallTxnFields.ClearStateProgram) + 5 + msgp.Uint32Size + 8 + (*z).CompactCertTxnFields.CertRound.Msgsize() + 9 + (*z).CompactCertTxnFields.CertType.Msgsize() + 5 + (*z).CompactCertTxnFields.Cert.Msgsize()
	return
}

// MsgIsZero returns whether this is a zero value
func (z *Transaction) MsgIsZero() bool {
	return ((*z).Type.MsgIsZero()) && ((*z).Header.Sender.MsgIsZero()) && ((*z).Header.Fee.MsgIsZero()) && ((*z).Header.FirstValid.MsgIsZero()) && ((*z).Header.LastValid.MsgIsZero()) && (len((*z).Header.Note) == 0) && ((*z).Header.GenesisID == "") && ((*z).Header.GenesisHash.MsgIsZero()) && ((*z).Header.Group.MsgIsZero()) && ((*z).Header.Lease == ([32]byte{})) && ((*z).Header.RekeyTo.MsgIsZero()) && ((*z).KeyregTxnFields.VotePK.MsgIsZero()) && ((*z).KeyregTxnFields.SelectionPK.MsgIsZero()) && ((*z).KeyregTxnFields.StateProofPK.MsgIsZero()) && ((*z).KeyregTxnFields.VoteFirst.MsgIsZero()) && ((*z).KeyregTxnFields.VoteLast.MsgIsZero()) && ((*z).KeyregTxnFields.VoteKeyDilution == 0) && ((*z).KeyregTxnFields.Nonparticipation == false) && ((*z).PaymentTxnFields.Receiver.MsgIsZero()) && ((*z).PaymentTxnFields.Amount.MsgIsZero()) && ((*z).PaymentTxnFields.CloseRemainderTo.MsgIsZero()) && ((*z).AssetConfigTxnFields.ConfigAsset.MsgIsZero()) && ((*z).AssetConfigTxnFields.AssetParams.MsgIsZero()) && ((*z).AssetTransferTxnFields.XferAsset.MsgIsZero()) && ((*z).AssetTransferTxnFields.AssetAmount == 0) && ((*z).AssetTransferTxnFields.AssetSender.MsgIsZero()) && ((*z).AssetTransferTxnFields.AssetReceiver.MsgIsZero()) && ((*z).AssetTransferTxnFields.AssetCloseTo.MsgIsZero()) && ((*z).AssetFreezeTxnFields.FreezeAccount.MsgIsZero()) && ((*z).AssetFreezeTxnFields.FreezeAsset.MsgIsZero()) && ((*z).AssetFreezeTxnFields.AssetFrozen == false) && ((*z).ApplicationCallTxnFields.ApplicationID.MsgIsZero()) && ((*z).ApplicationCallTxnFields.OnCompletion == 0) && (len((*z).ApplicationCallTxnFields.ApplicationArgs) == 0) && (len((*z).ApplicationCallTxnFields.Accounts) == 0) && (len((*z).ApplicationCallTxnFields.ForeignApps) == 0) && (len((*z).ApplicationCallTxnFields.ForeignAssets) == 0) && ((*z).ApplicationCallTxnFields.LocalStateSchema.MsgIsZero()) && ((*z).ApplicationCallTxnFields.GlobalStateSchema.MsgIsZero()) && (len((*z).ApplicationCallTxnFields.ApprovalProgram) == 0) && (len((*z).ApplicationCallTxnFields.ClearStateProgram) == 0) && ((*z).ApplicationCallTxnFields.ExtraProgramPages == 0) && ((*z).CompactCertTxnFields.CertRound.MsgIsZero()) && ((*z).CompactCertTxnFields.CertType.MsgIsZero()) && ((*z).CompactCertTxnFields.Cert.MsgIsZero())
}

// MarshalMsg implements msgp.Marshaler
func (z *TxGroup) MarshalMsg(b []byte) (o []byte) {
	o = msgp.Require(b, z.Msgsize())
	// omitempty: check for empty values
	zb0002Len := uint32(1)
	var zb0002Mask uint8 /* 2 bits */
	if len((*z).TxGroupHashes) == 0 {
		zb0002Len--
		zb0002Mask |= 0x2
	}
	// variable map header, size zb0002Len
	o = append(o, 0x80|uint8(zb0002Len))
	if zb0002Len != 0 {
		if (zb0002Mask & 0x2) == 0 { // if not empty
			// string "txlist"
			o = append(o, 0xa6, 0x74, 0x78, 0x6c, 0x69, 0x73, 0x74)
			if (*z).TxGroupHashes == nil {
				o = msgp.AppendNil(o)
			} else {
				o = msgp.AppendArrayHeader(o, uint32(len((*z).TxGroupHashes)))
			}
			for zb0001 := range (*z).TxGroupHashes {
				o = (*z).TxGroupHashes[zb0001].MarshalMsg(o)
			}
		}
	}
	return
}

func (_ *TxGroup) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*TxGroup)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *TxGroup) UnmarshalMsg(bts []byte) (o []byte, err error) {
	var field []byte
	_ = field
	var zb0002 int
	var zb0003 bool
	zb0002, zb0003, bts, err = msgp.ReadMapHeaderBytes(bts)
	if _, ok := err.(msgp.TypeError); ok {
		zb0002, zb0003, bts, err = msgp.ReadArrayHeaderBytes(bts)
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0002 > 0 {
			zb0002--
			var zb0004 int
			var zb0005 bool
			zb0004, zb0005, bts, err = msgp.ReadArrayHeaderBytes(bts)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array", "TxGroupHashes")
				return
			}
			if zb0004 > config.MaxTxGroupSize {
				err = msgp.ErrOverflow(uint64(zb0004), uint64(config.MaxTxGroupSize))
				err = msgp.WrapError(err, "struct-from-array", "TxGroupHashes")
				return
			}
			if zb0005 {
				(*z).TxGroupHashes = nil
			} else if (*z).TxGroupHashes != nil && cap((*z).TxGroupHashes) >= zb0004 {
				(*z).TxGroupHashes = ((*z).TxGroupHashes)[:zb0004]
			} else {
				(*z).TxGroupHashes = make([]crypto.Digest, zb0004)
			}
			for zb0001 := range (*z).TxGroupHashes {
				bts, err = (*z).TxGroupHashes[zb0001].UnmarshalMsg(bts)
				if err != nil {
					err = msgp.WrapError(err, "struct-from-array", "TxGroupHashes", zb0001)
					return
				}
			}
		}
		if zb0002 > 0 {
			err = msgp.ErrTooManyArrayFields(zb0002)
			if err != nil {
				err = msgp.WrapError(err, "struct-from-array")
				return
			}
		}
	} else {
		if err != nil {
			err = msgp.WrapError(err)
			return
		}
		if zb0003 {
			(*z) = TxGroup{}
		}
		for zb0002 > 0 {
			zb0002--
			field, bts, err = msgp.ReadMapKeyZC(bts)
			if err != nil {
				err = msgp.WrapError(err)
				return
			}
			switch string(field) {
			case "txlist":
				var zb0006 int
				var zb0007 bool
				zb0006, zb0007, bts, err = msgp.ReadArrayHeaderBytes(bts)
				if err != nil {
					err = msgp.WrapError(err, "TxGroupHashes")
					return
				}
				if zb0006 > config.MaxTxGroupSize {
					err = msgp.ErrOverflow(uint64(zb0006), uint64(config.MaxTxGroupSize))
					err = msgp.WrapError(err, "TxGroupHashes")
					return
				}
				if zb0007 {
					(*z).TxGroupHashes = nil
				} else if (*z).TxGroupHashes != nil && cap((*z).TxGroupHashes) >= zb0006 {
					(*z).TxGroupHashes = ((*z).TxGroupHashes)[:zb0006]
				} else {
					(*z).TxGroupHashes = make([]crypto.Digest, zb0006)
				}
				for zb0001 := range (*z).TxGroupHashes {
					bts, err = (*z).TxGroupHashes[zb0001].UnmarshalMsg(bts)
					if err != nil {
						err = msgp.WrapError(err, "TxGroupHashes", zb0001)
						return
					}
				}
			default:
				err = msgp.ErrNoField(string(field))
				if err != nil {
					err = msgp.WrapError(err)
					return
				}
			}
		}
	}
	o = bts
	return
}

func (_ *TxGroup) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*TxGroup)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *TxGroup) Msgsize() (s int) {
	s = 1 + 7 + msgp.ArrayHeaderSize
	for zb0001 := range (*z).TxGroupHashes {
		s += (*z).TxGroupHashes[zb0001].Msgsize()
	}
	return
}

// MsgIsZero returns whether this is a zero value
func (z *TxGroup) MsgIsZero() bool {
	return (len((*z).TxGroupHashes) == 0)
}

// MarshalMsg implements msgp.Marshaler
func (z *Txid) MarshalMsg(b []byte) []byte {
	return ((*(crypto.Digest))(z)).MarshalMsg(b)
}
func (_ *Txid) CanMarshalMsg(z interface{}) bool {
	_, ok := (z).(*Txid)
	return ok
}

// UnmarshalMsg implements msgp.Unmarshaler
func (z *Txid) UnmarshalMsg(bts []byte) ([]byte, error) {
	return ((*(crypto.Digest))(z)).UnmarshalMsg(bts)
}
func (_ *Txid) CanUnmarshalMsg(z interface{}) bool {
	_, ok := (z).(*Txid)
	return ok
}

// Msgsize returns an upper bound estimate of the number of bytes occupied by the serialized message
func (z *Txid) Msgsize() int {
	return ((*(crypto.Digest))(z)).Msgsize()
}

// MsgIsZero returns whether this is a zero value
func (z *Txid) MsgIsZero() bool {
	return ((*(crypto.Digest))(z)).MsgIsZero()
}
